(set-logic QF-UFLIA)


(declare-sort Loc)
(declare-sort Set)
(declare-sort MSet)

(declare-fun singleton (Int) Set)
(declare-fun union (Set Set) Set)
(declare-fun inter (Set Set) Set)
(declare-fun emptyset () Set)
(declare-fun in (Int Set) Bool)
(declare-fun subset (Set Set) Bool)
(declare-fun leq (Set Set) Bool)
(declare-fun eq (Set Set) Bool)

(declare-fun msingleton (Int) MSet)
(declare-fun munion (MSet MSet) MSet)
(declare-fun minter (MSet MSet) MSet)
(declare-fun emptymset () MSet)
(declare-fun msubset (MSet MSet) Bool)
(declare-fun mleq (MSet MSet) Bool)
(declare-fun meq (MSet MSet) Bool)

(declare-fun count (MSet Int) Int)


(declare-fun nil () Loc)
(declare-fun key (Loc) Int)
(declare-fun key' (Loc) Int)
(declare-fun l (Loc) Loc)
(declare-fun l' (Loc) Loc)
(declare-fun r (Loc) Loc)
(declare-fun r' (Loc) Loc)
(declare-fun heap (Loc) Bool)
(declare-fun heap' (Loc) Bool)
(declare-fun heap1 (Loc) Bool)

(declare-fun keys (Loc) MSet)
(declare-fun keys' (Loc) MSet)
(declare-fun keys1 (Loc) MSet)

(assert (heap nil))
(assert (heap' nil))
(assert (heap1 nil))
(assert (meq (keys nil) emptymset))
(assert (meq (keys' nil) emptymset))
(assert (meq (keys1 nil) emptymset))


(declare-fun cond1 () Bool)
(declare-fun cond2 () Bool)
(declare-fun cond3 () Bool)
(declare-fun cond4 () Bool)

; Vars
(declare-fun x () Loc)
(declare-fun w1 () Int)
(declare-fun w2 () Int)











(assert (not (in w1 emptyset)))
(assert (not (in w2 emptyset)))
(assert (not (in (key x) emptyset)))
(assert (not (in (key (l x)) emptyset)))
(assert (not (in (key (r x)) emptyset)))
(assert (not (in (key' (r x)) emptyset)))
(assert (not (in (key' x) emptyset)))
(assert (not (in (key' (l x)) emptyset)))

(assert (= (count (munion (keys (l x)) (msingleton (key x))) w1) (+ (count (keys (l x)) w1) (count (msingleton (key x)) w1))))
(assert (= (count (munion (keys (l x)) (msingleton (key x))) w2) (+ (count (keys (l x)) w2) (count (msingleton (key x)) w2))))
(assert (= (count (munion (keys (l x)) (msingleton (key x))) (key x)) (+ (count (keys (l x)) (key x)) (count (msingleton (key x)) (key x)))))
(assert (= (count (munion (keys (l x)) (msingleton (key x))) (key (l x))) (+ (count (keys (l x)) (key (l x))) (count (msingleton (key x)) (key (l x))))))
(assert (= (count (munion (keys (l x)) (msingleton (key x))) (key (r x))) (+ (count (keys (l x)) (key (r x))) (count (msingleton (key x)) (key (r x))))))
(assert (= (count (munion (keys (l x)) (msingleton (key x))) (key' (r x))) (+ (count (keys (l x)) (key' (r x))) (count (msingleton (key x)) (key' (r x))))))
(assert (= (count (munion (keys (l x)) (msingleton (key x))) (key' x)) (+ (count (keys (l x)) (key' x)) (count (msingleton (key x)) (key' x)))))
(assert (= (count (munion (keys (l x)) (msingleton (key x))) (key' (l x))) (+ (count (keys (l x)) (key' (l x))) (count (msingleton (key x)) (key' (l x))))))
(assert (= (count (munion (keys (l (l x))) (msingleton (key (l x)))) w1) (+ (count (keys (l (l x))) w1) (count (msingleton (key (l x))) w1))))
(assert (= (count (munion (keys (l (l x))) (msingleton (key (l x)))) w2) (+ (count (keys (l (l x))) w2) (count (msingleton (key (l x))) w2))))
(assert (= (count (munion (keys (l (l x))) (msingleton (key (l x)))) (key x)) (+ (count (keys (l (l x))) (key x)) (count (msingleton (key (l x))) (key x)))))
(assert (= (count (munion (keys (l (l x))) (msingleton (key (l x)))) (key (l x))) (+ (count (keys (l (l x))) (key (l x))) (count (msingleton (key (l x))) (key (l x))))))
(assert (= (count (munion (keys (l (l x))) (msingleton (key (l x)))) (key (r x))) (+ (count (keys (l (l x))) (key (r x))) (count (msingleton (key (l x))) (key (r x))))))
(assert (= (count (munion (keys (l (l x))) (msingleton (key (l x)))) (key' (r x))) (+ (count (keys (l (l x))) (key' (r x))) (count (msingleton (key (l x))) (key' (r x))))))
(assert (= (count (munion (keys (l (l x))) (msingleton (key (l x)))) (key' x)) (+ (count (keys (l (l x))) (key' x)) (count (msingleton (key (l x))) (key' x)))))
(assert (= (count (munion (keys (l (l x))) (msingleton (key (l x)))) (key' (l x))) (+ (count (keys (l (l x))) (key' (l x))) (count (msingleton (key (l x))) (key' (l x))))))
(assert (= (count (munion (keys (l (r x))) (msingleton (key (r x)))) w1) (+ (count (keys (l (r x))) w1) (count (msingleton (key (r x))) w1))))
(assert (= (count (munion (keys (l (r x))) (msingleton (key (r x)))) w2) (+ (count (keys (l (r x))) w2) (count (msingleton (key (r x))) w2))))
(assert (= (count (munion (keys (l (r x))) (msingleton (key (r x)))) (key x)) (+ (count (keys (l (r x))) (key x)) (count (msingleton (key (r x))) (key x)))))
(assert (= (count (munion (keys (l (r x))) (msingleton (key (r x)))) (key (l x))) (+ (count (keys (l (r x))) (key (l x))) (count (msingleton (key (r x))) (key (l x))))))
(assert (= (count (munion (keys (l (r x))) (msingleton (key (r x)))) (key (r x))) (+ (count (keys (l (r x))) (key (r x))) (count (msingleton (key (r x))) (key (r x))))))
(assert (= (count (munion (keys (l (r x))) (msingleton (key (r x)))) (key' (r x))) (+ (count (keys (l (r x))) (key' (r x))) (count (msingleton (key (r x))) (key' (r x))))))
(assert (= (count (munion (keys (l (r x))) (msingleton (key (r x)))) (key' x)) (+ (count (keys (l (r x))) (key' x)) (count (msingleton (key (r x))) (key' x)))))
(assert (= (count (munion (keys (l (r x))) (msingleton (key (r x)))) (key' (l x))) (+ (count (keys (l (r x))) (key' (l x))) (count (msingleton (key (r x))) (key' (l x))))))
(assert (= (count (munion (keys (r x)) (msingleton (key x))) w1) (+ (count (keys (r x)) w1) (count (msingleton (key x)) w1))))
(assert (= (count (munion (keys (r x)) (msingleton (key x))) w2) (+ (count (keys (r x)) w2) (count (msingleton (key x)) w2))))
(assert (= (count (munion (keys (r x)) (msingleton (key x))) (key x)) (+ (count (keys (r x)) (key x)) (count (msingleton (key x)) (key x)))))
(assert (= (count (munion (keys (r x)) (msingleton (key x))) (key (l x))) (+ (count (keys (r x)) (key (l x))) (count (msingleton (key x)) (key (l x))))))
(assert (= (count (munion (keys (r x)) (msingleton (key x))) (key (r x))) (+ (count (keys (r x)) (key (r x))) (count (msingleton (key x)) (key (r x))))))
(assert (= (count (munion (keys (r x)) (msingleton (key x))) (key' (r x))) (+ (count (keys (r x)) (key' (r x))) (count (msingleton (key x)) (key' (r x))))))
(assert (= (count (munion (keys (r x)) (msingleton (key x))) (key' x)) (+ (count (keys (r x)) (key' x)) (count (msingleton (key x)) (key' x)))))
(assert (= (count (munion (keys (r x)) (msingleton (key x))) (key' (l x))) (+ (count (keys (r x)) (key' (l x))) (count (msingleton (key x)) (key' (l x))))))
(assert (= (count (munion (keys (r (l x))) (msingleton (key (l x)))) w1) (+ (count (keys (r (l x))) w1) (count (msingleton (key (l x))) w1))))
(assert (= (count (munion (keys (r (l x))) (msingleton (key (l x)))) w2) (+ (count (keys (r (l x))) w2) (count (msingleton (key (l x))) w2))))
(assert (= (count (munion (keys (r (l x))) (msingleton (key (l x)))) (key x)) (+ (count (keys (r (l x))) (key x)) (count (msingleton (key (l x))) (key x)))))
(assert (= (count (munion (keys (r (l x))) (msingleton (key (l x)))) (key (l x))) (+ (count (keys (r (l x))) (key (l x))) (count (msingleton (key (l x))) (key (l x))))))
(assert (= (count (munion (keys (r (l x))) (msingleton (key (l x)))) (key (r x))) (+ (count (keys (r (l x))) (key (r x))) (count (msingleton (key (l x))) (key (r x))))))
(assert (= (count (munion (keys (r (l x))) (msingleton (key (l x)))) (key' (r x))) (+ (count (keys (r (l x))) (key' (r x))) (count (msingleton (key (l x))) (key' (r x))))))
(assert (= (count (munion (keys (r (l x))) (msingleton (key (l x)))) (key' x)) (+ (count (keys (r (l x))) (key' x)) (count (msingleton (key (l x))) (key' x)))))
(assert (= (count (munion (keys (r (l x))) (msingleton (key (l x)))) (key' (l x))) (+ (count (keys (r (l x))) (key' (l x))) (count (msingleton (key (l x))) (key' (l x))))))
(assert (= (count (munion (keys (r (r x))) (msingleton (key (r x)))) w1) (+ (count (keys (r (r x))) w1) (count (msingleton (key (r x))) w1))))
(assert (= (count (munion (keys (r (r x))) (msingleton (key (r x)))) w2) (+ (count (keys (r (r x))) w2) (count (msingleton (key (r x))) w2))))
(assert (= (count (munion (keys (r (r x))) (msingleton (key (r x)))) (key x)) (+ (count (keys (r (r x))) (key x)) (count (msingleton (key (r x))) (key x)))))
(assert (= (count (munion (keys (r (r x))) (msingleton (key (r x)))) (key (l x))) (+ (count (keys (r (r x))) (key (l x))) (count (msingleton (key (r x))) (key (l x))))))
(assert (= (count (munion (keys (r (r x))) (msingleton (key (r x)))) (key (r x))) (+ (count (keys (r (r x))) (key (r x))) (count (msingleton (key (r x))) (key (r x))))))
(assert (= (count (munion (keys (r (r x))) (msingleton (key (r x)))) (key' (r x))) (+ (count (keys (r (r x))) (key' (r x))) (count (msingleton (key (r x))) (key' (r x))))))
(assert (= (count (munion (keys (r (r x))) (msingleton (key (r x)))) (key' x)) (+ (count (keys (r (r x))) (key' x)) (count (msingleton (key (r x))) (key' x)))))
(assert (= (count (munion (keys (r (r x))) (msingleton (key (r x)))) (key' (l x))) (+ (count (keys (r (r x))) (key' (l x))) (count (msingleton (key (r x))) (key' (l x))))))
(assert (= (count (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x))) w1) (+ (count (munion (keys (l x)) (keys (r x))) w1) (count (msingleton (key x)) w1))))
(assert (= (count (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x))) w2) (+ (count (munion (keys (l x)) (keys (r x))) w2) (count (msingleton (key x)) w2))))
(assert (= (count (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x))) (key x)) (+ (count (munion (keys (l x)) (keys (r x))) (key x)) (count (msingleton (key x)) (key x)))))
(assert (= (count (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x))) (key (l x))) (+ (count (munion (keys (l x)) (keys (r x))) (key (l x))) (count (msingleton (key x)) (key (l x))))))
(assert (= (count (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x))) (key (r x))) (+ (count (munion (keys (l x)) (keys (r x))) (key (r x))) (count (msingleton (key x)) (key (r x))))))
(assert (= (count (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x))) (key' (r x))) (+ (count (munion (keys (l x)) (keys (r x))) (key' (r x))) (count (msingleton (key x)) (key' (r x))))))
(assert (= (count (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x))) (key' x)) (+ (count (munion (keys (l x)) (keys (r x))) (key' x)) (count (msingleton (key x)) (key' x)))))
(assert (= (count (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x))) (key' (l x))) (+ (count (munion (keys (l x)) (keys (r x))) (key' (l x))) (count (msingleton (key x)) (key' (l x))))))
(assert (= (count (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x)))) w1) (+ (count (munion (keys (l (l x))) (keys (r (l x)))) w1) (count (msingleton (key (l x))) w1))))
(assert (= (count (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x)))) w2) (+ (count (munion (keys (l (l x))) (keys (r (l x)))) w2) (count (msingleton (key (l x))) w2))))
(assert (= (count (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x)))) (key x)) (+ (count (munion (keys (l (l x))) (keys (r (l x)))) (key x)) (count (msingleton (key (l x))) (key x)))))
(assert (= (count (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x)))) (key (l x))) (+ (count (munion (keys (l (l x))) (keys (r (l x)))) (key (l x))) (count (msingleton (key (l x))) (key (l x))))))
(assert (= (count (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x)))) (key (r x))) (+ (count (munion (keys (l (l x))) (keys (r (l x)))) (key (r x))) (count (msingleton (key (l x))) (key (r x))))))
(assert (= (count (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x)))) (key' (r x))) (+ (count (munion (keys (l (l x))) (keys (r (l x)))) (key' (r x))) (count (msingleton (key (l x))) (key' (r x))))))
(assert (= (count (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x)))) (key' x)) (+ (count (munion (keys (l (l x))) (keys (r (l x)))) (key' x)) (count (msingleton (key (l x))) (key' x)))))
(assert (= (count (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x)))) (key' (l x))) (+ (count (munion (keys (l (l x))) (keys (r (l x)))) (key' (l x))) (count (msingleton (key (l x))) (key' (l x))))))
(assert (= (count (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x)))) w1) (+ (count (munion (keys (l (r x))) (keys (r (r x)))) w1) (count (msingleton (key (r x))) w1))))
(assert (= (count (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x)))) w2) (+ (count (munion (keys (l (r x))) (keys (r (r x)))) w2) (count (msingleton (key (r x))) w2))))
(assert (= (count (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x)))) (key x)) (+ (count (munion (keys (l (r x))) (keys (r (r x)))) (key x)) (count (msingleton (key (r x))) (key x)))))
(assert (= (count (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x)))) (key (l x))) (+ (count (munion (keys (l (r x))) (keys (r (r x)))) (key (l x))) (count (msingleton (key (r x))) (key (l x))))))
(assert (= (count (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x)))) (key (r x))) (+ (count (munion (keys (l (r x))) (keys (r (r x)))) (key (r x))) (count (msingleton (key (r x))) (key (r x))))))
(assert (= (count (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x)))) (key' (r x))) (+ (count (munion (keys (l (r x))) (keys (r (r x)))) (key' (r x))) (count (msingleton (key (r x))) (key' (r x))))))
(assert (= (count (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x)))) (key' x)) (+ (count (munion (keys (l (r x))) (keys (r (r x)))) (key' x)) (count (msingleton (key (r x))) (key' x)))))
(assert (= (count (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x)))) (key' (l x))) (+ (count (munion (keys (l (r x))) (keys (r (r x)))) (key' (l x))) (count (msingleton (key (r x))) (key' (l x))))))
(assert (= (count (munion (keys (l x)) (keys (r x))) w1) (+ (count (keys (l x)) w1) (count (keys (r x)) w1))))
(assert (= (count (munion (keys (l x)) (keys (r x))) w2) (+ (count (keys (l x)) w2) (count (keys (r x)) w2))))
(assert (= (count (munion (keys (l x)) (keys (r x))) (key x)) (+ (count (keys (l x)) (key x)) (count (keys (r x)) (key x)))))
(assert (= (count (munion (keys (l x)) (keys (r x))) (key (l x))) (+ (count (keys (l x)) (key (l x))) (count (keys (r x)) (key (l x))))))
(assert (= (count (munion (keys (l x)) (keys (r x))) (key (r x))) (+ (count (keys (l x)) (key (r x))) (count (keys (r x)) (key (r x))))))
(assert (= (count (munion (keys (l x)) (keys (r x))) (key' (r x))) (+ (count (keys (l x)) (key' (r x))) (count (keys (r x)) (key' (r x))))))
(assert (= (count (munion (keys (l x)) (keys (r x))) (key' x)) (+ (count (keys (l x)) (key' x)) (count (keys (r x)) (key' x)))))
(assert (= (count (munion (keys (l x)) (keys (r x))) (key' (l x))) (+ (count (keys (l x)) (key' (l x))) (count (keys (r x)) (key' (l x))))))
(assert (= (count (munion (keys (l (l x))) (keys (r (l x)))) w1) (+ (count (keys (l (l x))) w1) (count (keys (r (l x))) w1))))
(assert (= (count (munion (keys (l (l x))) (keys (r (l x)))) w2) (+ (count (keys (l (l x))) w2) (count (keys (r (l x))) w2))))
(assert (= (count (munion (keys (l (l x))) (keys (r (l x)))) (key x)) (+ (count (keys (l (l x))) (key x)) (count (keys (r (l x))) (key x)))))
(assert (= (count (munion (keys (l (l x))) (keys (r (l x)))) (key (l x))) (+ (count (keys (l (l x))) (key (l x))) (count (keys (r (l x))) (key (l x))))))
(assert (= (count (munion (keys (l (l x))) (keys (r (l x)))) (key (r x))) (+ (count (keys (l (l x))) (key (r x))) (count (keys (r (l x))) (key (r x))))))
(assert (= (count (munion (keys (l (l x))) (keys (r (l x)))) (key' (r x))) (+ (count (keys (l (l x))) (key' (r x))) (count (keys (r (l x))) (key' (r x))))))
(assert (= (count (munion (keys (l (l x))) (keys (r (l x)))) (key' x)) (+ (count (keys (l (l x))) (key' x)) (count (keys (r (l x))) (key' x)))))
(assert (= (count (munion (keys (l (l x))) (keys (r (l x)))) (key' (l x))) (+ (count (keys (l (l x))) (key' (l x))) (count (keys (r (l x))) (key' (l x))))))
(assert (= (count (munion (keys (l (r x))) (keys (r (r x)))) w1) (+ (count (keys (l (r x))) w1) (count (keys (r (r x))) w1))))
(assert (= (count (munion (keys (l (r x))) (keys (r (r x)))) w2) (+ (count (keys (l (r x))) w2) (count (keys (r (r x))) w2))))
(assert (= (count (munion (keys (l (r x))) (keys (r (r x)))) (key x)) (+ (count (keys (l (r x))) (key x)) (count (keys (r (r x))) (key x)))))
(assert (= (count (munion (keys (l (r x))) (keys (r (r x)))) (key (l x))) (+ (count (keys (l (r x))) (key (l x))) (count (keys (r (r x))) (key (l x))))))
(assert (= (count (munion (keys (l (r x))) (keys (r (r x)))) (key (r x))) (+ (count (keys (l (r x))) (key (r x))) (count (keys (r (r x))) (key (r x))))))
(assert (= (count (munion (keys (l (r x))) (keys (r (r x)))) (key' (r x))) (+ (count (keys (l (r x))) (key' (r x))) (count (keys (r (r x))) (key' (r x))))))
(assert (= (count (munion (keys (l (r x))) (keys (r (r x)))) (key' x)) (+ (count (keys (l (r x))) (key' x)) (count (keys (r (r x))) (key' x)))))
(assert (= (count (munion (keys (l (r x))) (keys (r (r x)))) (key' (l x))) (+ (count (keys (l (r x))) (key' (l x))) (count (keys (r (r x))) (key' (l x))))))



(assert (= (count (msingleton (key x)) w1) (ite (= w1 (key x)) 1 0)))
(assert (= (count (msingleton (key x)) w2) (ite (= w2 (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (key x)) (ite (= (key x) (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (key (l x))) (ite (= (key (l x)) (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (key (r x))) (ite (= (key (r x)) (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (key' (r x))) (ite (= (key' (r x)) (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (key' x)) (ite (= (key' x) (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (key' (l x))) (ite (= (key' (l x)) (key x)) 1 0)))
(assert (= (count (msingleton (key (l x))) w1) (ite (= w1 (key (l x))) 1 0)))
(assert (= (count (msingleton (key (l x))) w2) (ite (= w2 (key (l x))) 1 0)))
(assert (= (count (msingleton (key (l x))) (key x)) (ite (= (key x) (key (l x))) 1 0)))
(assert (= (count (msingleton (key (l x))) (key (l x))) (ite (= (key (l x)) (key (l x))) 1 0)))
(assert (= (count (msingleton (key (l x))) (key (r x))) (ite (= (key (r x)) (key (l x))) 1 0)))
(assert (= (count (msingleton (key (l x))) (key' (r x))) (ite (= (key' (r x)) (key (l x))) 1 0)))
(assert (= (count (msingleton (key (l x))) (key' x)) (ite (= (key' x) (key (l x))) 1 0)))
(assert (= (count (msingleton (key (l x))) (key' (l x))) (ite (= (key' (l x)) (key (l x))) 1 0)))
(assert (= (count (msingleton (key (r x))) w1) (ite (= w1 (key (r x))) 1 0)))
(assert (= (count (msingleton (key (r x))) w2) (ite (= w2 (key (r x))) 1 0)))
(assert (= (count (msingleton (key (r x))) (key x)) (ite (= (key x) (key (r x))) 1 0)))
(assert (= (count (msingleton (key (r x))) (key (l x))) (ite (= (key (l x)) (key (r x))) 1 0)))
(assert (= (count (msingleton (key (r x))) (key (r x))) (ite (= (key (r x)) (key (r x))) 1 0)))
(assert (= (count (msingleton (key (r x))) (key' (r x))) (ite (= (key' (r x)) (key (r x))) 1 0)))
(assert (= (count (msingleton (key (r x))) (key' x)) (ite (= (key' x) (key (r x))) 1 0)))
(assert (= (count (msingleton (key (r x))) (key' (l x))) (ite (= (key' (l x)) (key (r x))) 1 0)))


(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) w1) (count emptymset w1))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) w2) (count emptymset w2))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (key x)) (count emptymset (key x)))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (key (l x))) (count emptymset (key (l x))))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (key (r x))) (count emptymset (key (r x))))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (key' (r x))) (count emptymset (key' (r x))))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (key' x)) (count emptymset (key' x)))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (key' (l x))) (count emptymset (key' (l x))))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) w1) (count emptymset w1))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) w2) (count emptymset w2))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (key x)) (count emptymset (key x)))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (key (l x))) (count emptymset (key (l x))))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (key (r x))) (count emptymset (key (r x))))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (key' (r x))) (count emptymset (key' (r x))))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (key' x)) (count emptymset (key' x)))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (key' (l x))) (count emptymset (key' (l x))))))
(assert (=> (meq (keys1 nil) emptymset) (= (count (keys1 nil) w1) (count emptymset w1))))
(assert (=> (meq (keys1 nil) emptymset) (= (count (keys1 nil) w2) (count emptymset w2))))
(assert (=> (meq (keys1 nil) emptymset) (= (count (keys1 nil) (key x)) (count emptymset (key x)))))
(assert (=> (meq (keys1 nil) emptymset) (= (count (keys1 nil) (key (l x))) (count emptymset (key (l x))))))
(assert (=> (meq (keys1 nil) emptymset) (= (count (keys1 nil) (key (r x))) (count emptymset (key (r x))))))
(assert (=> (meq (keys1 nil) emptymset) (= (count (keys1 nil) (key' (r x))) (count emptymset (key' (r x))))))
(assert (=> (meq (keys1 nil) emptymset) (= (count (keys1 nil) (key' x)) (count emptymset (key' x)))))
(assert (=> (meq (keys1 nil) emptymset) (= (count (keys1 nil) (key' (l x))) (count emptymset (key' (l x))))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) w1) (count emptymset w1))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) w2) (count emptymset w2))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (key x)) (count emptymset (key x)))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (key (l x))) (count emptymset (key (l x))))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (key (r x))) (count emptymset (key (r x))))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (key' (r x))) (count emptymset (key' (r x))))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (key' x)) (count emptymset (key' x)))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (key' (l x))) (count emptymset (key' (l x))))))
(assert (=> (meq (keys (l x)) emptymset) (= (count (keys (l x)) w1) (count emptymset w1))))
(assert (=> (meq (keys (l x)) emptymset) (= (count (keys (l x)) w2) (count emptymset w2))))
(assert (=> (meq (keys (l x)) emptymset) (= (count (keys (l x)) (key x)) (count emptymset (key x)))))
(assert (=> (meq (keys (l x)) emptymset) (= (count (keys (l x)) (key (l x))) (count emptymset (key (l x))))))
(assert (=> (meq (keys (l x)) emptymset) (= (count (keys (l x)) (key (r x))) (count emptymset (key (r x))))))
(assert (=> (meq (keys (l x)) emptymset) (= (count (keys (l x)) (key' (r x))) (count emptymset (key' (r x))))))
(assert (=> (meq (keys (l x)) emptymset) (= (count (keys (l x)) (key' x)) (count emptymset (key' x)))))
(assert (=> (meq (keys (l x)) emptymset) (= (count (keys (l x)) (key' (l x))) (count emptymset (key' (l x))))))
(assert (=> (meq (keys (r x)) emptymset) (= (count (keys (r x)) w1) (count emptymset w1))))
(assert (=> (meq (keys (r x)) emptymset) (= (count (keys (r x)) w2) (count emptymset w2))))
(assert (=> (meq (keys (r x)) emptymset) (= (count (keys (r x)) (key x)) (count emptymset (key x)))))
(assert (=> (meq (keys (r x)) emptymset) (= (count (keys (r x)) (key (l x))) (count emptymset (key (l x))))))
(assert (=> (meq (keys (r x)) emptymset) (= (count (keys (r x)) (key (r x))) (count emptymset (key (r x))))))
(assert (=> (meq (keys (r x)) emptymset) (= (count (keys (r x)) (key' (r x))) (count emptymset (key' (r x))))))
(assert (=> (meq (keys (r x)) emptymset) (= (count (keys (r x)) (key' x)) (count emptymset (key' x)))))
(assert (=> (meq (keys (r x)) emptymset) (= (count (keys (r x)) (key' (l x))) (count emptymset (key' (l x))))))
(assert (=> (meq (keys x) (msingleton (key x))) (= (count (keys x) w1) (count (msingleton (key x)) w1))))
(assert (=> (meq (keys x) (msingleton (key x))) (= (count (keys x) w2) (count (msingleton (key x)) w2))))
(assert (=> (meq (keys x) (msingleton (key x))) (= (count (keys x) (key x)) (count (msingleton (key x)) (key x)))))
(assert (=> (meq (keys x) (msingleton (key x))) (= (count (keys x) (key (l x))) (count (msingleton (key x)) (key (l x))))))
(assert (=> (meq (keys x) (msingleton (key x))) (= (count (keys x) (key (r x))) (count (msingleton (key x)) (key (r x))))))
(assert (=> (meq (keys x) (msingleton (key x))) (= (count (keys x) (key' (r x))) (count (msingleton (key x)) (key' (r x))))))
(assert (=> (meq (keys x) (msingleton (key x))) (= (count (keys x) (key' x)) (count (msingleton (key x)) (key' x)))))
(assert (=> (meq (keys x) (msingleton (key x))) (= (count (keys x) (key' (l x))) (count (msingleton (key x)) (key' (l x))))))
(assert (=> (meq (keys (l x)) (msingleton (key (l x)))) (= (count (keys (l x)) w1) (count (msingleton (key (l x))) w1))))
(assert (=> (meq (keys (l x)) (msingleton (key (l x)))) (= (count (keys (l x)) w2) (count (msingleton (key (l x))) w2))))
(assert (=> (meq (keys (l x)) (msingleton (key (l x)))) (= (count (keys (l x)) (key x)) (count (msingleton (key (l x))) (key x)))))
(assert (=> (meq (keys (l x)) (msingleton (key (l x)))) (= (count (keys (l x)) (key (l x))) (count (msingleton (key (l x))) (key (l x))))))
(assert (=> (meq (keys (l x)) (msingleton (key (l x)))) (= (count (keys (l x)) (key (r x))) (count (msingleton (key (l x))) (key (r x))))))
(assert (=> (meq (keys (l x)) (msingleton (key (l x)))) (= (count (keys (l x)) (key' (r x))) (count (msingleton (key (l x))) (key' (r x))))))
(assert (=> (meq (keys (l x)) (msingleton (key (l x)))) (= (count (keys (l x)) (key' x)) (count (msingleton (key (l x))) (key' x)))))
(assert (=> (meq (keys (l x)) (msingleton (key (l x)))) (= (count (keys (l x)) (key' (l x))) (count (msingleton (key (l x))) (key' (l x))))))
(assert (=> (meq (keys (r x)) (msingleton (key (r x)))) (= (count (keys (r x)) w1) (count (msingleton (key (r x))) w1))))
(assert (=> (meq (keys (r x)) (msingleton (key (r x)))) (= (count (keys (r x)) w2) (count (msingleton (key (r x))) w2))))
(assert (=> (meq (keys (r x)) (msingleton (key (r x)))) (= (count (keys (r x)) (key x)) (count (msingleton (key (r x))) (key x)))))
(assert (=> (meq (keys (r x)) (msingleton (key (r x)))) (= (count (keys (r x)) (key (l x))) (count (msingleton (key (r x))) (key (l x))))))
(assert (=> (meq (keys (r x)) (msingleton (key (r x)))) (= (count (keys (r x)) (key (r x))) (count (msingleton (key (r x))) (key (r x))))))
(assert (=> (meq (keys (r x)) (msingleton (key (r x)))) (= (count (keys (r x)) (key' (r x))) (count (msingleton (key (r x))) (key' (r x))))))
(assert (=> (meq (keys (r x)) (msingleton (key (r x)))) (= (count (keys (r x)) (key' x)) (count (msingleton (key (r x))) (key' x)))))
(assert (=> (meq (keys (r x)) (msingleton (key (r x)))) (= (count (keys (r x)) (key' (l x))) (count (msingleton (key (r x))) (key' (l x))))))
(assert (=> (meq (keys x) (munion (keys (l x)) (msingleton (key x)))) (= (count (keys x) w1) (count (munion (keys (l x)) (msingleton (key x))) w1))))
(assert (=> (meq (keys x) (munion (keys (l x)) (msingleton (key x)))) (= (count (keys x) w2) (count (munion (keys (l x)) (msingleton (key x))) w2))))
(assert (=> (meq (keys x) (munion (keys (l x)) (msingleton (key x)))) (= (count (keys x) (key x)) (count (munion (keys (l x)) (msingleton (key x))) (key x)))))
(assert (=> (meq (keys x) (munion (keys (l x)) (msingleton (key x)))) (= (count (keys x) (key (l x))) (count (munion (keys (l x)) (msingleton (key x))) (key (l x))))))
(assert (=> (meq (keys x) (munion (keys (l x)) (msingleton (key x)))) (= (count (keys x) (key (r x))) (count (munion (keys (l x)) (msingleton (key x))) (key (r x))))))
(assert (=> (meq (keys x) (munion (keys (l x)) (msingleton (key x)))) (= (count (keys x) (key' (r x))) (count (munion (keys (l x)) (msingleton (key x))) (key' (r x))))))
(assert (=> (meq (keys x) (munion (keys (l x)) (msingleton (key x)))) (= (count (keys x) (key' x)) (count (munion (keys (l x)) (msingleton (key x))) (key' x)))))
(assert (=> (meq (keys x) (munion (keys (l x)) (msingleton (key x)))) (= (count (keys x) (key' (l x))) (count (munion (keys (l x)) (msingleton (key x))) (key' (l x))))))
(assert (=> (meq (keys (l x)) (munion (keys (l (l x))) (msingleton (key (l x))))) (= (count (keys (l x)) w1) (count (munion (keys (l (l x))) (msingleton (key (l x)))) w1))))
(assert (=> (meq (keys (l x)) (munion (keys (l (l x))) (msingleton (key (l x))))) (= (count (keys (l x)) w2) (count (munion (keys (l (l x))) (msingleton (key (l x)))) w2))))
(assert (=> (meq (keys (l x)) (munion (keys (l (l x))) (msingleton (key (l x))))) (= (count (keys (l x)) (key x)) (count (munion (keys (l (l x))) (msingleton (key (l x)))) (key x)))))
(assert (=> (meq (keys (l x)) (munion (keys (l (l x))) (msingleton (key (l x))))) (= (count (keys (l x)) (key (l x))) (count (munion (keys (l (l x))) (msingleton (key (l x)))) (key (l x))))))
(assert (=> (meq (keys (l x)) (munion (keys (l (l x))) (msingleton (key (l x))))) (= (count (keys (l x)) (key (r x))) (count (munion (keys (l (l x))) (msingleton (key (l x)))) (key (r x))))))
(assert (=> (meq (keys (l x)) (munion (keys (l (l x))) (msingleton (key (l x))))) (= (count (keys (l x)) (key' (r x))) (count (munion (keys (l (l x))) (msingleton (key (l x)))) (key' (r x))))))
(assert (=> (meq (keys (l x)) (munion (keys (l (l x))) (msingleton (key (l x))))) (= (count (keys (l x)) (key' x)) (count (munion (keys (l (l x))) (msingleton (key (l x)))) (key' x)))))
(assert (=> (meq (keys (l x)) (munion (keys (l (l x))) (msingleton (key (l x))))) (= (count (keys (l x)) (key' (l x))) (count (munion (keys (l (l x))) (msingleton (key (l x)))) (key' (l x))))))
(assert (=> (meq (keys (r x)) (munion (keys (l (r x))) (msingleton (key (r x))))) (= (count (keys (r x)) w1) (count (munion (keys (l (r x))) (msingleton (key (r x)))) w1))))
(assert (=> (meq (keys (r x)) (munion (keys (l (r x))) (msingleton (key (r x))))) (= (count (keys (r x)) w2) (count (munion (keys (l (r x))) (msingleton (key (r x)))) w2))))
(assert (=> (meq (keys (r x)) (munion (keys (l (r x))) (msingleton (key (r x))))) (= (count (keys (r x)) (key x)) (count (munion (keys (l (r x))) (msingleton (key (r x)))) (key x)))))
(assert (=> (meq (keys (r x)) (munion (keys (l (r x))) (msingleton (key (r x))))) (= (count (keys (r x)) (key (l x))) (count (munion (keys (l (r x))) (msingleton (key (r x)))) (key (l x))))))
(assert (=> (meq (keys (r x)) (munion (keys (l (r x))) (msingleton (key (r x))))) (= (count (keys (r x)) (key (r x))) (count (munion (keys (l (r x))) (msingleton (key (r x)))) (key (r x))))))
(assert (=> (meq (keys (r x)) (munion (keys (l (r x))) (msingleton (key (r x))))) (= (count (keys (r x)) (key' (r x))) (count (munion (keys (l (r x))) (msingleton (key (r x)))) (key' (r x))))))
(assert (=> (meq (keys (r x)) (munion (keys (l (r x))) (msingleton (key (r x))))) (= (count (keys (r x)) (key' x)) (count (munion (keys (l (r x))) (msingleton (key (r x)))) (key' x)))))
(assert (=> (meq (keys (r x)) (munion (keys (l (r x))) (msingleton (key (r x))))) (= (count (keys (r x)) (key' (l x))) (count (munion (keys (l (r x))) (msingleton (key (r x)))) (key' (l x))))))
(assert (=> (meq (keys x) (munion (keys (r x)) (msingleton (key x)))) (= (count (keys x) w1) (count (munion (keys (r x)) (msingleton (key x))) w1))))
(assert (=> (meq (keys x) (munion (keys (r x)) (msingleton (key x)))) (= (count (keys x) w2) (count (munion (keys (r x)) (msingleton (key x))) w2))))
(assert (=> (meq (keys x) (munion (keys (r x)) (msingleton (key x)))) (= (count (keys x) (key x)) (count (munion (keys (r x)) (msingleton (key x))) (key x)))))
(assert (=> (meq (keys x) (munion (keys (r x)) (msingleton (key x)))) (= (count (keys x) (key (l x))) (count (munion (keys (r x)) (msingleton (key x))) (key (l x))))))
(assert (=> (meq (keys x) (munion (keys (r x)) (msingleton (key x)))) (= (count (keys x) (key (r x))) (count (munion (keys (r x)) (msingleton (key x))) (key (r x))))))
(assert (=> (meq (keys x) (munion (keys (r x)) (msingleton (key x)))) (= (count (keys x) (key' (r x))) (count (munion (keys (r x)) (msingleton (key x))) (key' (r x))))))
(assert (=> (meq (keys x) (munion (keys (r x)) (msingleton (key x)))) (= (count (keys x) (key' x)) (count (munion (keys (r x)) (msingleton (key x))) (key' x)))))
(assert (=> (meq (keys x) (munion (keys (r x)) (msingleton (key x)))) (= (count (keys x) (key' (l x))) (count (munion (keys (r x)) (msingleton (key x))) (key' (l x))))))
(assert (=> (meq (keys (l x)) (munion (keys (r (l x))) (msingleton (key (l x))))) (= (count (keys (l x)) w1) (count (munion (keys (r (l x))) (msingleton (key (l x)))) w1))))
(assert (=> (meq (keys (l x)) (munion (keys (r (l x))) (msingleton (key (l x))))) (= (count (keys (l x)) w2) (count (munion (keys (r (l x))) (msingleton (key (l x)))) w2))))
(assert (=> (meq (keys (l x)) (munion (keys (r (l x))) (msingleton (key (l x))))) (= (count (keys (l x)) (key x)) (count (munion (keys (r (l x))) (msingleton (key (l x)))) (key x)))))
(assert (=> (meq (keys (l x)) (munion (keys (r (l x))) (msingleton (key (l x))))) (= (count (keys (l x)) (key (l x))) (count (munion (keys (r (l x))) (msingleton (key (l x)))) (key (l x))))))
(assert (=> (meq (keys (l x)) (munion (keys (r (l x))) (msingleton (key (l x))))) (= (count (keys (l x)) (key (r x))) (count (munion (keys (r (l x))) (msingleton (key (l x)))) (key (r x))))))
(assert (=> (meq (keys (l x)) (munion (keys (r (l x))) (msingleton (key (l x))))) (= (count (keys (l x)) (key' (r x))) (count (munion (keys (r (l x))) (msingleton (key (l x)))) (key' (r x))))))
(assert (=> (meq (keys (l x)) (munion (keys (r (l x))) (msingleton (key (l x))))) (= (count (keys (l x)) (key' x)) (count (munion (keys (r (l x))) (msingleton (key (l x)))) (key' x)))))
(assert (=> (meq (keys (l x)) (munion (keys (r (l x))) (msingleton (key (l x))))) (= (count (keys (l x)) (key' (l x))) (count (munion (keys (r (l x))) (msingleton (key (l x)))) (key' (l x))))))
(assert (=> (meq (keys (r x)) (munion (keys (r (r x))) (msingleton (key (r x))))) (= (count (keys (r x)) w1) (count (munion (keys (r (r x))) (msingleton (key (r x)))) w1))))
(assert (=> (meq (keys (r x)) (munion (keys (r (r x))) (msingleton (key (r x))))) (= (count (keys (r x)) w2) (count (munion (keys (r (r x))) (msingleton (key (r x)))) w2))))
(assert (=> (meq (keys (r x)) (munion (keys (r (r x))) (msingleton (key (r x))))) (= (count (keys (r x)) (key x)) (count (munion (keys (r (r x))) (msingleton (key (r x)))) (key x)))))
(assert (=> (meq (keys (r x)) (munion (keys (r (r x))) (msingleton (key (r x))))) (= (count (keys (r x)) (key (l x))) (count (munion (keys (r (r x))) (msingleton (key (r x)))) (key (l x))))))
(assert (=> (meq (keys (r x)) (munion (keys (r (r x))) (msingleton (key (r x))))) (= (count (keys (r x)) (key (r x))) (count (munion (keys (r (r x))) (msingleton (key (r x)))) (key (r x))))))
(assert (=> (meq (keys (r x)) (munion (keys (r (r x))) (msingleton (key (r x))))) (= (count (keys (r x)) (key' (r x))) (count (munion (keys (r (r x))) (msingleton (key (r x)))) (key' (r x))))))
(assert (=> (meq (keys (r x)) (munion (keys (r (r x))) (msingleton (key (r x))))) (= (count (keys (r x)) (key' x)) (count (munion (keys (r (r x))) (msingleton (key (r x)))) (key' x)))))
(assert (=> (meq (keys (r x)) (munion (keys (r (r x))) (msingleton (key (r x))))) (= (count (keys (r x)) (key' (l x))) (count (munion (keys (r (r x))) (msingleton (key (r x)))) (key' (l x))))))
(assert (=> (meq (keys x) (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x)))) (= (count (keys x) w1) (count (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x))) w1))))
(assert (=> (meq (keys x) (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x)))) (= (count (keys x) w2) (count (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x))) w2))))
(assert (=> (meq (keys x) (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x)))) (= (count (keys x) (key x)) (count (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x))) (key x)))))
(assert (=> (meq (keys x) (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x)))) (= (count (keys x) (key (l x))) (count (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x))) (key (l x))))))
(assert (=> (meq (keys x) (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x)))) (= (count (keys x) (key (r x))) (count (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x))) (key (r x))))))
(assert (=> (meq (keys x) (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x)))) (= (count (keys x) (key' (r x))) (count (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x))) (key' (r x))))))
(assert (=> (meq (keys x) (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x)))) (= (count (keys x) (key' x)) (count (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x))) (key' x)))))
(assert (=> (meq (keys x) (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x)))) (= (count (keys x) (key' (l x))) (count (munion (munion (keys (l x)) (keys (r x))) (msingleton (key x))) (key' (l x))))))
(assert (=> (meq (keys (l x)) (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x))))) (= (count (keys (l x)) w1) (count (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x)))) w1))))
(assert (=> (meq (keys (l x)) (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x))))) (= (count (keys (l x)) w2) (count (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x)))) w2))))
(assert (=> (meq (keys (l x)) (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x))))) (= (count (keys (l x)) (key x)) (count (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x)))) (key x)))))
(assert (=> (meq (keys (l x)) (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x))))) (= (count (keys (l x)) (key (l x))) (count (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x)))) (key (l x))))))
(assert (=> (meq (keys (l x)) (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x))))) (= (count (keys (l x)) (key (r x))) (count (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x)))) (key (r x))))))
(assert (=> (meq (keys (l x)) (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x))))) (= (count (keys (l x)) (key' (r x))) (count (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x)))) (key' (r x))))))
(assert (=> (meq (keys (l x)) (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x))))) (= (count (keys (l x)) (key' x)) (count (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x)))) (key' x)))))
(assert (=> (meq (keys (l x)) (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x))))) (= (count (keys (l x)) (key' (l x))) (count (munion (munion (keys (l (l x))) (keys (r (l x)))) (msingleton (key (l x)))) (key' (l x))))))
(assert (=> (meq (keys (r x)) (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x))))) (= (count (keys (r x)) w1) (count (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x)))) w1))))
(assert (=> (meq (keys (r x)) (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x))))) (= (count (keys (r x)) w2) (count (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x)))) w2))))
(assert (=> (meq (keys (r x)) (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x))))) (= (count (keys (r x)) (key x)) (count (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x)))) (key x)))))
(assert (=> (meq (keys (r x)) (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x))))) (= (count (keys (r x)) (key (l x))) (count (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x)))) (key (l x))))))
(assert (=> (meq (keys (r x)) (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x))))) (= (count (keys (r x)) (key (r x))) (count (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x)))) (key (r x))))))
(assert (=> (meq (keys (r x)) (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x))))) (= (count (keys (r x)) (key' (r x))) (count (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x)))) (key' (r x))))))
(assert (=> (meq (keys (r x)) (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x))))) (= (count (keys (r x)) (key' x)) (count (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x)))) (key' x)))))
(assert (=> (meq (keys (r x)) (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x))))) (= (count (keys (r x)) (key' (l x))) (count (munion (munion (keys (l (r x))) (keys (r (r x)))) (msingleton (key (r x)))) (key' (l x))))))
(assert (=> (meq (keys (l (l x))) (keys1 (l (l x)))) (= (count (keys (l (l x))) w1) (count (keys1 (l (l x))) w1))))
(assert (=> (meq (keys (l (l x))) (keys1 (l (l x)))) (= (count (keys (l (l x))) w2) (count (keys1 (l (l x))) w2))))
(assert (=> (meq (keys (l (l x))) (keys1 (l (l x)))) (= (count (keys (l (l x))) (key x)) (count (keys1 (l (l x))) (key x)))))
(assert (=> (meq (keys (l (l x))) (keys1 (l (l x)))) (= (count (keys (l (l x))) (key (l x))) (count (keys1 (l (l x))) (key (l x))))))
(assert (=> (meq (keys (l (l x))) (keys1 (l (l x)))) (= (count (keys (l (l x))) (key (r x))) (count (keys1 (l (l x))) (key (r x))))))
(assert (=> (meq (keys (l (l x))) (keys1 (l (l x)))) (= (count (keys (l (l x))) (key' (r x))) (count (keys1 (l (l x))) (key' (r x))))))
(assert (=> (meq (keys (l (l x))) (keys1 (l (l x)))) (= (count (keys (l (l x))) (key' x)) (count (keys1 (l (l x))) (key' x)))))
(assert (=> (meq (keys (l (l x))) (keys1 (l (l x)))) (= (count (keys (l (l x))) (key' (l x))) (count (keys1 (l (l x))) (key' (l x))))))
(assert (=> (meq (keys (r (l x))) (keys1 (r (l x)))) (= (count (keys (r (l x))) w1) (count (keys1 (r (l x))) w1))))
(assert (=> (meq (keys (r (l x))) (keys1 (r (l x)))) (= (count (keys (r (l x))) w2) (count (keys1 (r (l x))) w2))))
(assert (=> (meq (keys (r (l x))) (keys1 (r (l x)))) (= (count (keys (r (l x))) (key x)) (count (keys1 (r (l x))) (key x)))))
(assert (=> (meq (keys (r (l x))) (keys1 (r (l x)))) (= (count (keys (r (l x))) (key (l x))) (count (keys1 (r (l x))) (key (l x))))))
(assert (=> (meq (keys (r (l x))) (keys1 (r (l x)))) (= (count (keys (r (l x))) (key (r x))) (count (keys1 (r (l x))) (key (r x))))))
(assert (=> (meq (keys (r (l x))) (keys1 (r (l x)))) (= (count (keys (r (l x))) (key' (r x))) (count (keys1 (r (l x))) (key' (r x))))))
(assert (=> (meq (keys (r (l x))) (keys1 (r (l x)))) (= (count (keys (r (l x))) (key' x)) (count (keys1 (r (l x))) (key' x)))))
(assert (=> (meq (keys (r (l x))) (keys1 (r (l x)))) (= (count (keys (r (l x))) (key' (l x))) (count (keys1 (r (l x))) (key' (l x))))))
(assert (=> (meq (keys (l (r x))) (keys1 (l (r x)))) (= (count (keys (l (r x))) w1) (count (keys1 (l (r x))) w1))))
(assert (=> (meq (keys (l (r x))) (keys1 (l (r x)))) (= (count (keys (l (r x))) w2) (count (keys1 (l (r x))) w2))))
(assert (=> (meq (keys (l (r x))) (keys1 (l (r x)))) (= (count (keys (l (r x))) (key x)) (count (keys1 (l (r x))) (key x)))))
(assert (=> (meq (keys (l (r x))) (keys1 (l (r x)))) (= (count (keys (l (r x))) (key (l x))) (count (keys1 (l (r x))) (key (l x))))))
(assert (=> (meq (keys (l (r x))) (keys1 (l (r x)))) (= (count (keys (l (r x))) (key (r x))) (count (keys1 (l (r x))) (key (r x))))))
(assert (=> (meq (keys (l (r x))) (keys1 (l (r x)))) (= (count (keys (l (r x))) (key' (r x))) (count (keys1 (l (r x))) (key' (r x))))))
(assert (=> (meq (keys (l (r x))) (keys1 (l (r x)))) (= (count (keys (l (r x))) (key' x)) (count (keys1 (l (r x))) (key' x)))))
(assert (=> (meq (keys (l (r x))) (keys1 (l (r x)))) (= (count (keys (l (r x))) (key' (l x))) (count (keys1 (l (r x))) (key' (l x))))))
(assert (=> (meq (keys (r (r x))) (keys1 (r (r x)))) (= (count (keys (r (r x))) w1) (count (keys1 (r (r x))) w1))))
(assert (=> (meq (keys (r (r x))) (keys1 (r (r x)))) (= (count (keys (r (r x))) w2) (count (keys1 (r (r x))) w2))))
(assert (=> (meq (keys (r (r x))) (keys1 (r (r x)))) (= (count (keys (r (r x))) (key x)) (count (keys1 (r (r x))) (key x)))))
(assert (=> (meq (keys (r (r x))) (keys1 (r (r x)))) (= (count (keys (r (r x))) (key (l x))) (count (keys1 (r (r x))) (key (l x))))))
(assert (=> (meq (keys (r (r x))) (keys1 (r (r x)))) (= (count (keys (r (r x))) (key (r x))) (count (keys1 (r (r x))) (key (r x))))))
(assert (=> (meq (keys (r (r x))) (keys1 (r (r x)))) (= (count (keys (r (r x))) (key' (r x))) (count (keys1 (r (r x))) (key' (r x))))))
(assert (=> (meq (keys (r (r x))) (keys1 (r (r x)))) (= (count (keys (r (r x))) (key' x)) (count (keys1 (r (r x))) (key' x)))))
(assert (=> (meq (keys (r (r x))) (keys1 (r (r x)))) (= (count (keys (r (r x))) (key' (l x))) (count (keys1 (r (r x))) (key' (l x))))))



(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) w1) 0) (> (count (msingleton (key x)) w1) 0)) (<= w1 w1))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) w1) 0) (> (count (msingleton (key x)) w2) 0)) (<= w1 w2))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) w1) 0) (> (count (msingleton (key x)) (key x)) 0)) (<= w1 (key x)))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) w1) 0) (> (count (msingleton (key x)) (key (l x))) 0)) (<= w1 (key (l x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) w1) 0) (> (count (msingleton (key x)) (key (r x))) 0)) (<= w1 (key (r x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) w1) 0) (> (count (msingleton (key x)) (key' (r x))) 0)) (<= w1 (key' (r x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) w1) 0) (> (count (msingleton (key x)) (key' x)) 0)) (<= w1 (key' x)))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) w1) 0) (> (count (msingleton (key x)) (key' (l x))) 0)) (<= w1 (key' (l x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) w2) 0) (> (count (msingleton (key x)) w1) 0)) (<= w2 w1))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) w2) 0) (> (count (msingleton (key x)) w2) 0)) (<= w2 w2))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) w2) 0) (> (count (msingleton (key x)) (key x)) 0)) (<= w2 (key x)))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) w2) 0) (> (count (msingleton (key x)) (key (l x))) 0)) (<= w2 (key (l x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) w2) 0) (> (count (msingleton (key x)) (key (r x))) 0)) (<= w2 (key (r x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) w2) 0) (> (count (msingleton (key x)) (key' (r x))) 0)) (<= w2 (key' (r x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) w2) 0) (> (count (msingleton (key x)) (key' x)) 0)) (<= w2 (key' x)))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) w2) 0) (> (count (msingleton (key x)) (key' (l x))) 0)) (<= w2 (key' (l x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key x)) 0) (> (count (msingleton (key x)) w1) 0)) (<= (key x) w1))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key x)) 0) (> (count (msingleton (key x)) w2) 0)) (<= (key x) w2))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key x)) 0) (> (count (msingleton (key x)) (key x)) 0)) (<= (key x) (key x)))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key x)) 0) (> (count (msingleton (key x)) (key (l x))) 0)) (<= (key x) (key (l x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key x)) 0) (> (count (msingleton (key x)) (key (r x))) 0)) (<= (key x) (key (r x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key x)) 0) (> (count (msingleton (key x)) (key' (r x))) 0)) (<= (key x) (key' (r x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key x)) 0) (> (count (msingleton (key x)) (key' x)) 0)) (<= (key x) (key' x)))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key x)) 0) (> (count (msingleton (key x)) (key' (l x))) 0)) (<= (key x) (key' (l x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key (l x))) 0) (> (count (msingleton (key x)) w1) 0)) (<= (key (l x)) w1))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key (l x))) 0) (> (count (msingleton (key x)) w2) 0)) (<= (key (l x)) w2))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key (l x))) 0) (> (count (msingleton (key x)) (key x)) 0)) (<= (key (l x)) (key x)))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key (l x))) 0) (> (count (msingleton (key x)) (key (l x))) 0)) (<= (key (l x)) (key (l x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key (l x))) 0) (> (count (msingleton (key x)) (key (r x))) 0)) (<= (key (l x)) (key (r x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key (l x))) 0) (> (count (msingleton (key x)) (key' (r x))) 0)) (<= (key (l x)) (key' (r x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key (l x))) 0) (> (count (msingleton (key x)) (key' x)) 0)) (<= (key (l x)) (key' x)))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key (l x))) 0) (> (count (msingleton (key x)) (key' (l x))) 0)) (<= (key (l x)) (key' (l x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key (r x))) 0) (> (count (msingleton (key x)) w1) 0)) (<= (key (r x)) w1))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key (r x))) 0) (> (count (msingleton (key x)) w2) 0)) (<= (key (r x)) w2))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key (r x))) 0) (> (count (msingleton (key x)) (key x)) 0)) (<= (key (r x)) (key x)))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key (r x))) 0) (> (count (msingleton (key x)) (key (l x))) 0)) (<= (key (r x)) (key (l x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key (r x))) 0) (> (count (msingleton (key x)) (key (r x))) 0)) (<= (key (r x)) (key (r x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key (r x))) 0) (> (count (msingleton (key x)) (key' (r x))) 0)) (<= (key (r x)) (key' (r x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key (r x))) 0) (> (count (msingleton (key x)) (key' x)) 0)) (<= (key (r x)) (key' x)))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key (r x))) 0) (> (count (msingleton (key x)) (key' (l x))) 0)) (<= (key (r x)) (key' (l x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' (r x))) 0) (> (count (msingleton (key x)) w1) 0)) (<= (key' (r x)) w1))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' (r x))) 0) (> (count (msingleton (key x)) w2) 0)) (<= (key' (r x)) w2))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' (r x))) 0) (> (count (msingleton (key x)) (key x)) 0)) (<= (key' (r x)) (key x)))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' (r x))) 0) (> (count (msingleton (key x)) (key (l x))) 0)) (<= (key' (r x)) (key (l x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' (r x))) 0) (> (count (msingleton (key x)) (key (r x))) 0)) (<= (key' (r x)) (key (r x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' (r x))) 0) (> (count (msingleton (key x)) (key' (r x))) 0)) (<= (key' (r x)) (key' (r x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' (r x))) 0) (> (count (msingleton (key x)) (key' x)) 0)) (<= (key' (r x)) (key' x)))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' (r x))) 0) (> (count (msingleton (key x)) (key' (l x))) 0)) (<= (key' (r x)) (key' (l x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' x)) 0) (> (count (msingleton (key x)) w1) 0)) (<= (key' x) w1))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' x)) 0) (> (count (msingleton (key x)) w2) 0)) (<= (key' x) w2))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' x)) 0) (> (count (msingleton (key x)) (key x)) 0)) (<= (key' x) (key x)))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' x)) 0) (> (count (msingleton (key x)) (key (l x))) 0)) (<= (key' x) (key (l x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' x)) 0) (> (count (msingleton (key x)) (key (r x))) 0)) (<= (key' x) (key (r x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' x)) 0) (> (count (msingleton (key x)) (key' (r x))) 0)) (<= (key' x) (key' (r x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' x)) 0) (> (count (msingleton (key x)) (key' x)) 0)) (<= (key' x) (key' x)))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' x)) 0) (> (count (msingleton (key x)) (key' (l x))) 0)) (<= (key' x) (key' (l x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' (l x))) 0) (> (count (msingleton (key x)) w1) 0)) (<= (key' (l x)) w1))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' (l x))) 0) (> (count (msingleton (key x)) w2) 0)) (<= (key' (l x)) w2))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' (l x))) 0) (> (count (msingleton (key x)) (key x)) 0)) (<= (key' (l x)) (key x)))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' (l x))) 0) (> (count (msingleton (key x)) (key (l x))) 0)) (<= (key' (l x)) (key (l x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' (l x))) 0) (> (count (msingleton (key x)) (key (r x))) 0)) (<= (key' (l x)) (key (r x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' (l x))) 0) (> (count (msingleton (key x)) (key' (r x))) 0)) (<= (key' (l x)) (key' (r x))))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' (l x))) 0) (> (count (msingleton (key x)) (key' x)) 0)) (<= (key' (l x)) (key' x)))))
(assert (=> (mleq (keys (l x)) (msingleton (key x))) (=> (and (> (count (keys (l x)) (key' (l x))) 0) (> (count (msingleton (key x)) (key' (l x))) 0)) (<= (key' (l x)) (key' (l x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) w1) 0) (> (count (msingleton (key (l x))) w1) 0)) (<= w1 w1))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) w1) 0) (> (count (msingleton (key (l x))) w2) 0)) (<= w1 w2))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) w1) 0) (> (count (msingleton (key (l x))) (key x)) 0)) (<= w1 (key x)))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) w1) 0) (> (count (msingleton (key (l x))) (key (l x))) 0)) (<= w1 (key (l x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) w1) 0) (> (count (msingleton (key (l x))) (key (r x))) 0)) (<= w1 (key (r x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) w1) 0) (> (count (msingleton (key (l x))) (key' (r x))) 0)) (<= w1 (key' (r x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) w1) 0) (> (count (msingleton (key (l x))) (key' x)) 0)) (<= w1 (key' x)))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) w1) 0) (> (count (msingleton (key (l x))) (key' (l x))) 0)) (<= w1 (key' (l x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) w2) 0) (> (count (msingleton (key (l x))) w1) 0)) (<= w2 w1))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) w2) 0) (> (count (msingleton (key (l x))) w2) 0)) (<= w2 w2))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) w2) 0) (> (count (msingleton (key (l x))) (key x)) 0)) (<= w2 (key x)))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) w2) 0) (> (count (msingleton (key (l x))) (key (l x))) 0)) (<= w2 (key (l x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) w2) 0) (> (count (msingleton (key (l x))) (key (r x))) 0)) (<= w2 (key (r x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) w2) 0) (> (count (msingleton (key (l x))) (key' (r x))) 0)) (<= w2 (key' (r x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) w2) 0) (> (count (msingleton (key (l x))) (key' x)) 0)) (<= w2 (key' x)))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) w2) 0) (> (count (msingleton (key (l x))) (key' (l x))) 0)) (<= w2 (key' (l x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key x)) 0) (> (count (msingleton (key (l x))) w1) 0)) (<= (key x) w1))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key x)) 0) (> (count (msingleton (key (l x))) w2) 0)) (<= (key x) w2))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key x)) 0) (> (count (msingleton (key (l x))) (key x)) 0)) (<= (key x) (key x)))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key x)) 0) (> (count (msingleton (key (l x))) (key (l x))) 0)) (<= (key x) (key (l x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key x)) 0) (> (count (msingleton (key (l x))) (key (r x))) 0)) (<= (key x) (key (r x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key x)) 0) (> (count (msingleton (key (l x))) (key' (r x))) 0)) (<= (key x) (key' (r x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key x)) 0) (> (count (msingleton (key (l x))) (key' x)) 0)) (<= (key x) (key' x)))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key x)) 0) (> (count (msingleton (key (l x))) (key' (l x))) 0)) (<= (key x) (key' (l x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key (l x))) 0) (> (count (msingleton (key (l x))) w1) 0)) (<= (key (l x)) w1))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key (l x))) 0) (> (count (msingleton (key (l x))) w2) 0)) (<= (key (l x)) w2))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key (l x))) 0) (> (count (msingleton (key (l x))) (key x)) 0)) (<= (key (l x)) (key x)))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key (l x))) 0) (> (count (msingleton (key (l x))) (key (l x))) 0)) (<= (key (l x)) (key (l x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key (l x))) 0) (> (count (msingleton (key (l x))) (key (r x))) 0)) (<= (key (l x)) (key (r x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key (l x))) 0) (> (count (msingleton (key (l x))) (key' (r x))) 0)) (<= (key (l x)) (key' (r x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key (l x))) 0) (> (count (msingleton (key (l x))) (key' x)) 0)) (<= (key (l x)) (key' x)))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key (l x))) 0) (> (count (msingleton (key (l x))) (key' (l x))) 0)) (<= (key (l x)) (key' (l x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key (r x))) 0) (> (count (msingleton (key (l x))) w1) 0)) (<= (key (r x)) w1))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key (r x))) 0) (> (count (msingleton (key (l x))) w2) 0)) (<= (key (r x)) w2))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key (r x))) 0) (> (count (msingleton (key (l x))) (key x)) 0)) (<= (key (r x)) (key x)))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key (r x))) 0) (> (count (msingleton (key (l x))) (key (l x))) 0)) (<= (key (r x)) (key (l x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key (r x))) 0) (> (count (msingleton (key (l x))) (key (r x))) 0)) (<= (key (r x)) (key (r x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key (r x))) 0) (> (count (msingleton (key (l x))) (key' (r x))) 0)) (<= (key (r x)) (key' (r x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key (r x))) 0) (> (count (msingleton (key (l x))) (key' x)) 0)) (<= (key (r x)) (key' x)))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key (r x))) 0) (> (count (msingleton (key (l x))) (key' (l x))) 0)) (<= (key (r x)) (key' (l x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' (r x))) 0) (> (count (msingleton (key (l x))) w1) 0)) (<= (key' (r x)) w1))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' (r x))) 0) (> (count (msingleton (key (l x))) w2) 0)) (<= (key' (r x)) w2))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' (r x))) 0) (> (count (msingleton (key (l x))) (key x)) 0)) (<= (key' (r x)) (key x)))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' (r x))) 0) (> (count (msingleton (key (l x))) (key (l x))) 0)) (<= (key' (r x)) (key (l x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' (r x))) 0) (> (count (msingleton (key (l x))) (key (r x))) 0)) (<= (key' (r x)) (key (r x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' (r x))) 0) (> (count (msingleton (key (l x))) (key' (r x))) 0)) (<= (key' (r x)) (key' (r x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' (r x))) 0) (> (count (msingleton (key (l x))) (key' x)) 0)) (<= (key' (r x)) (key' x)))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' (r x))) 0) (> (count (msingleton (key (l x))) (key' (l x))) 0)) (<= (key' (r x)) (key' (l x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' x)) 0) (> (count (msingleton (key (l x))) w1) 0)) (<= (key' x) w1))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' x)) 0) (> (count (msingleton (key (l x))) w2) 0)) (<= (key' x) w2))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' x)) 0) (> (count (msingleton (key (l x))) (key x)) 0)) (<= (key' x) (key x)))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' x)) 0) (> (count (msingleton (key (l x))) (key (l x))) 0)) (<= (key' x) (key (l x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' x)) 0) (> (count (msingleton (key (l x))) (key (r x))) 0)) (<= (key' x) (key (r x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' x)) 0) (> (count (msingleton (key (l x))) (key' (r x))) 0)) (<= (key' x) (key' (r x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' x)) 0) (> (count (msingleton (key (l x))) (key' x)) 0)) (<= (key' x) (key' x)))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' x)) 0) (> (count (msingleton (key (l x))) (key' (l x))) 0)) (<= (key' x) (key' (l x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' (l x))) 0) (> (count (msingleton (key (l x))) w1) 0)) (<= (key' (l x)) w1))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' (l x))) 0) (> (count (msingleton (key (l x))) w2) 0)) (<= (key' (l x)) w2))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' (l x))) 0) (> (count (msingleton (key (l x))) (key x)) 0)) (<= (key' (l x)) (key x)))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' (l x))) 0) (> (count (msingleton (key (l x))) (key (l x))) 0)) (<= (key' (l x)) (key (l x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' (l x))) 0) (> (count (msingleton (key (l x))) (key (r x))) 0)) (<= (key' (l x)) (key (r x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' (l x))) 0) (> (count (msingleton (key (l x))) (key' (r x))) 0)) (<= (key' (l x)) (key' (r x))))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' (l x))) 0) (> (count (msingleton (key (l x))) (key' x)) 0)) (<= (key' (l x)) (key' x)))))
(assert (=> (mleq (keys (l (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (l (l x))) (key' (l x))) 0) (> (count (msingleton (key (l x))) (key' (l x))) 0)) (<= (key' (l x)) (key' (l x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) w1) 0) (> (count (msingleton (key (r x))) w1) 0)) (<= w1 w1))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) w1) 0) (> (count (msingleton (key (r x))) w2) 0)) (<= w1 w2))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) w1) 0) (> (count (msingleton (key (r x))) (key x)) 0)) (<= w1 (key x)))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) w1) 0) (> (count (msingleton (key (r x))) (key (l x))) 0)) (<= w1 (key (l x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) w1) 0) (> (count (msingleton (key (r x))) (key (r x))) 0)) (<= w1 (key (r x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) w1) 0) (> (count (msingleton (key (r x))) (key' (r x))) 0)) (<= w1 (key' (r x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) w1) 0) (> (count (msingleton (key (r x))) (key' x)) 0)) (<= w1 (key' x)))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) w1) 0) (> (count (msingleton (key (r x))) (key' (l x))) 0)) (<= w1 (key' (l x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) w2) 0) (> (count (msingleton (key (r x))) w1) 0)) (<= w2 w1))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) w2) 0) (> (count (msingleton (key (r x))) w2) 0)) (<= w2 w2))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) w2) 0) (> (count (msingleton (key (r x))) (key x)) 0)) (<= w2 (key x)))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) w2) 0) (> (count (msingleton (key (r x))) (key (l x))) 0)) (<= w2 (key (l x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) w2) 0) (> (count (msingleton (key (r x))) (key (r x))) 0)) (<= w2 (key (r x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) w2) 0) (> (count (msingleton (key (r x))) (key' (r x))) 0)) (<= w2 (key' (r x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) w2) 0) (> (count (msingleton (key (r x))) (key' x)) 0)) (<= w2 (key' x)))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) w2) 0) (> (count (msingleton (key (r x))) (key' (l x))) 0)) (<= w2 (key' (l x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key x)) 0) (> (count (msingleton (key (r x))) w1) 0)) (<= (key x) w1))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key x)) 0) (> (count (msingleton (key (r x))) w2) 0)) (<= (key x) w2))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key x)) 0) (> (count (msingleton (key (r x))) (key x)) 0)) (<= (key x) (key x)))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key x)) 0) (> (count (msingleton (key (r x))) (key (l x))) 0)) (<= (key x) (key (l x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key x)) 0) (> (count (msingleton (key (r x))) (key (r x))) 0)) (<= (key x) (key (r x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key x)) 0) (> (count (msingleton (key (r x))) (key' (r x))) 0)) (<= (key x) (key' (r x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key x)) 0) (> (count (msingleton (key (r x))) (key' x)) 0)) (<= (key x) (key' x)))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key x)) 0) (> (count (msingleton (key (r x))) (key' (l x))) 0)) (<= (key x) (key' (l x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key (l x))) 0) (> (count (msingleton (key (r x))) w1) 0)) (<= (key (l x)) w1))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key (l x))) 0) (> (count (msingleton (key (r x))) w2) 0)) (<= (key (l x)) w2))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key (l x))) 0) (> (count (msingleton (key (r x))) (key x)) 0)) (<= (key (l x)) (key x)))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key (l x))) 0) (> (count (msingleton (key (r x))) (key (l x))) 0)) (<= (key (l x)) (key (l x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key (l x))) 0) (> (count (msingleton (key (r x))) (key (r x))) 0)) (<= (key (l x)) (key (r x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key (l x))) 0) (> (count (msingleton (key (r x))) (key' (r x))) 0)) (<= (key (l x)) (key' (r x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key (l x))) 0) (> (count (msingleton (key (r x))) (key' x)) 0)) (<= (key (l x)) (key' x)))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key (l x))) 0) (> (count (msingleton (key (r x))) (key' (l x))) 0)) (<= (key (l x)) (key' (l x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key (r x))) 0) (> (count (msingleton (key (r x))) w1) 0)) (<= (key (r x)) w1))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key (r x))) 0) (> (count (msingleton (key (r x))) w2) 0)) (<= (key (r x)) w2))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key (r x))) 0) (> (count (msingleton (key (r x))) (key x)) 0)) (<= (key (r x)) (key x)))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key (r x))) 0) (> (count (msingleton (key (r x))) (key (l x))) 0)) (<= (key (r x)) (key (l x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key (r x))) 0) (> (count (msingleton (key (r x))) (key (r x))) 0)) (<= (key (r x)) (key (r x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key (r x))) 0) (> (count (msingleton (key (r x))) (key' (r x))) 0)) (<= (key (r x)) (key' (r x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key (r x))) 0) (> (count (msingleton (key (r x))) (key' x)) 0)) (<= (key (r x)) (key' x)))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key (r x))) 0) (> (count (msingleton (key (r x))) (key' (l x))) 0)) (<= (key (r x)) (key' (l x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' (r x))) 0) (> (count (msingleton (key (r x))) w1) 0)) (<= (key' (r x)) w1))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' (r x))) 0) (> (count (msingleton (key (r x))) w2) 0)) (<= (key' (r x)) w2))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' (r x))) 0) (> (count (msingleton (key (r x))) (key x)) 0)) (<= (key' (r x)) (key x)))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' (r x))) 0) (> (count (msingleton (key (r x))) (key (l x))) 0)) (<= (key' (r x)) (key (l x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' (r x))) 0) (> (count (msingleton (key (r x))) (key (r x))) 0)) (<= (key' (r x)) (key (r x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' (r x))) 0) (> (count (msingleton (key (r x))) (key' (r x))) 0)) (<= (key' (r x)) (key' (r x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' (r x))) 0) (> (count (msingleton (key (r x))) (key' x)) 0)) (<= (key' (r x)) (key' x)))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' (r x))) 0) (> (count (msingleton (key (r x))) (key' (l x))) 0)) (<= (key' (r x)) (key' (l x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' x)) 0) (> (count (msingleton (key (r x))) w1) 0)) (<= (key' x) w1))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' x)) 0) (> (count (msingleton (key (r x))) w2) 0)) (<= (key' x) w2))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' x)) 0) (> (count (msingleton (key (r x))) (key x)) 0)) (<= (key' x) (key x)))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' x)) 0) (> (count (msingleton (key (r x))) (key (l x))) 0)) (<= (key' x) (key (l x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' x)) 0) (> (count (msingleton (key (r x))) (key (r x))) 0)) (<= (key' x) (key (r x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' x)) 0) (> (count (msingleton (key (r x))) (key' (r x))) 0)) (<= (key' x) (key' (r x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' x)) 0) (> (count (msingleton (key (r x))) (key' x)) 0)) (<= (key' x) (key' x)))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' x)) 0) (> (count (msingleton (key (r x))) (key' (l x))) 0)) (<= (key' x) (key' (l x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' (l x))) 0) (> (count (msingleton (key (r x))) w1) 0)) (<= (key' (l x)) w1))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' (l x))) 0) (> (count (msingleton (key (r x))) w2) 0)) (<= (key' (l x)) w2))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' (l x))) 0) (> (count (msingleton (key (r x))) (key x)) 0)) (<= (key' (l x)) (key x)))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' (l x))) 0) (> (count (msingleton (key (r x))) (key (l x))) 0)) (<= (key' (l x)) (key (l x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' (l x))) 0) (> (count (msingleton (key (r x))) (key (r x))) 0)) (<= (key' (l x)) (key (r x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' (l x))) 0) (> (count (msingleton (key (r x))) (key' (r x))) 0)) (<= (key' (l x)) (key' (r x))))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' (l x))) 0) (> (count (msingleton (key (r x))) (key' x)) 0)) (<= (key' (l x)) (key' x)))))
(assert (=> (mleq (keys (l (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (l (r x))) (key' (l x))) 0) (> (count (msingleton (key (r x))) (key' (l x))) 0)) (<= (key' (l x)) (key' (l x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) w1) 0) (> (count (msingleton (key x)) w1) 0)) (<= w1 w1))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) w1) 0) (> (count (msingleton (key x)) w2) 0)) (<= w1 w2))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) w1) 0) (> (count (msingleton (key x)) (key x)) 0)) (<= w1 (key x)))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) w1) 0) (> (count (msingleton (key x)) (key (l x))) 0)) (<= w1 (key (l x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) w1) 0) (> (count (msingleton (key x)) (key (r x))) 0)) (<= w1 (key (r x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) w1) 0) (> (count (msingleton (key x)) (key' (r x))) 0)) (<= w1 (key' (r x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) w1) 0) (> (count (msingleton (key x)) (key' x)) 0)) (<= w1 (key' x)))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) w1) 0) (> (count (msingleton (key x)) (key' (l x))) 0)) (<= w1 (key' (l x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) w2) 0) (> (count (msingleton (key x)) w1) 0)) (<= w2 w1))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) w2) 0) (> (count (msingleton (key x)) w2) 0)) (<= w2 w2))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) w2) 0) (> (count (msingleton (key x)) (key x)) 0)) (<= w2 (key x)))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) w2) 0) (> (count (msingleton (key x)) (key (l x))) 0)) (<= w2 (key (l x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) w2) 0) (> (count (msingleton (key x)) (key (r x))) 0)) (<= w2 (key (r x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) w2) 0) (> (count (msingleton (key x)) (key' (r x))) 0)) (<= w2 (key' (r x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) w2) 0) (> (count (msingleton (key x)) (key' x)) 0)) (<= w2 (key' x)))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) w2) 0) (> (count (msingleton (key x)) (key' (l x))) 0)) (<= w2 (key' (l x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key x)) 0) (> (count (msingleton (key x)) w1) 0)) (<= (key x) w1))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key x)) 0) (> (count (msingleton (key x)) w2) 0)) (<= (key x) w2))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key x)) 0) (> (count (msingleton (key x)) (key x)) 0)) (<= (key x) (key x)))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key x)) 0) (> (count (msingleton (key x)) (key (l x))) 0)) (<= (key x) (key (l x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key x)) 0) (> (count (msingleton (key x)) (key (r x))) 0)) (<= (key x) (key (r x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key x)) 0) (> (count (msingleton (key x)) (key' (r x))) 0)) (<= (key x) (key' (r x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key x)) 0) (> (count (msingleton (key x)) (key' x)) 0)) (<= (key x) (key' x)))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key x)) 0) (> (count (msingleton (key x)) (key' (l x))) 0)) (<= (key x) (key' (l x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key (l x))) 0) (> (count (msingleton (key x)) w1) 0)) (<= (key (l x)) w1))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key (l x))) 0) (> (count (msingleton (key x)) w2) 0)) (<= (key (l x)) w2))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key (l x))) 0) (> (count (msingleton (key x)) (key x)) 0)) (<= (key (l x)) (key x)))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key (l x))) 0) (> (count (msingleton (key x)) (key (l x))) 0)) (<= (key (l x)) (key (l x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key (l x))) 0) (> (count (msingleton (key x)) (key (r x))) 0)) (<= (key (l x)) (key (r x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key (l x))) 0) (> (count (msingleton (key x)) (key' (r x))) 0)) (<= (key (l x)) (key' (r x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key (l x))) 0) (> (count (msingleton (key x)) (key' x)) 0)) (<= (key (l x)) (key' x)))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key (l x))) 0) (> (count (msingleton (key x)) (key' (l x))) 0)) (<= (key (l x)) (key' (l x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key (r x))) 0) (> (count (msingleton (key x)) w1) 0)) (<= (key (r x)) w1))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key (r x))) 0) (> (count (msingleton (key x)) w2) 0)) (<= (key (r x)) w2))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key (r x))) 0) (> (count (msingleton (key x)) (key x)) 0)) (<= (key (r x)) (key x)))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key (r x))) 0) (> (count (msingleton (key x)) (key (l x))) 0)) (<= (key (r x)) (key (l x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key (r x))) 0) (> (count (msingleton (key x)) (key (r x))) 0)) (<= (key (r x)) (key (r x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key (r x))) 0) (> (count (msingleton (key x)) (key' (r x))) 0)) (<= (key (r x)) (key' (r x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key (r x))) 0) (> (count (msingleton (key x)) (key' x)) 0)) (<= (key (r x)) (key' x)))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key (r x))) 0) (> (count (msingleton (key x)) (key' (l x))) 0)) (<= (key (r x)) (key' (l x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' (r x))) 0) (> (count (msingleton (key x)) w1) 0)) (<= (key' (r x)) w1))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' (r x))) 0) (> (count (msingleton (key x)) w2) 0)) (<= (key' (r x)) w2))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' (r x))) 0) (> (count (msingleton (key x)) (key x)) 0)) (<= (key' (r x)) (key x)))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' (r x))) 0) (> (count (msingleton (key x)) (key (l x))) 0)) (<= (key' (r x)) (key (l x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' (r x))) 0) (> (count (msingleton (key x)) (key (r x))) 0)) (<= (key' (r x)) (key (r x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' (r x))) 0) (> (count (msingleton (key x)) (key' (r x))) 0)) (<= (key' (r x)) (key' (r x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' (r x))) 0) (> (count (msingleton (key x)) (key' x)) 0)) (<= (key' (r x)) (key' x)))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' (r x))) 0) (> (count (msingleton (key x)) (key' (l x))) 0)) (<= (key' (r x)) (key' (l x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' x)) 0) (> (count (msingleton (key x)) w1) 0)) (<= (key' x) w1))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' x)) 0) (> (count (msingleton (key x)) w2) 0)) (<= (key' x) w2))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' x)) 0) (> (count (msingleton (key x)) (key x)) 0)) (<= (key' x) (key x)))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' x)) 0) (> (count (msingleton (key x)) (key (l x))) 0)) (<= (key' x) (key (l x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' x)) 0) (> (count (msingleton (key x)) (key (r x))) 0)) (<= (key' x) (key (r x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' x)) 0) (> (count (msingleton (key x)) (key' (r x))) 0)) (<= (key' x) (key' (r x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' x)) 0) (> (count (msingleton (key x)) (key' x)) 0)) (<= (key' x) (key' x)))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' x)) 0) (> (count (msingleton (key x)) (key' (l x))) 0)) (<= (key' x) (key' (l x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' (l x))) 0) (> (count (msingleton (key x)) w1) 0)) (<= (key' (l x)) w1))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' (l x))) 0) (> (count (msingleton (key x)) w2) 0)) (<= (key' (l x)) w2))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' (l x))) 0) (> (count (msingleton (key x)) (key x)) 0)) (<= (key' (l x)) (key x)))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' (l x))) 0) (> (count (msingleton (key x)) (key (l x))) 0)) (<= (key' (l x)) (key (l x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' (l x))) 0) (> (count (msingleton (key x)) (key (r x))) 0)) (<= (key' (l x)) (key (r x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' (l x))) 0) (> (count (msingleton (key x)) (key' (r x))) 0)) (<= (key' (l x)) (key' (r x))))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' (l x))) 0) (> (count (msingleton (key x)) (key' x)) 0)) (<= (key' (l x)) (key' x)))))
(assert (=> (mleq (keys (r x)) (msingleton (key x))) (=> (and (> (count (keys (r x)) (key' (l x))) 0) (> (count (msingleton (key x)) (key' (l x))) 0)) (<= (key' (l x)) (key' (l x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) w1) 0) (> (count (msingleton (key (l x))) w1) 0)) (<= w1 w1))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) w1) 0) (> (count (msingleton (key (l x))) w2) 0)) (<= w1 w2))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) w1) 0) (> (count (msingleton (key (l x))) (key x)) 0)) (<= w1 (key x)))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) w1) 0) (> (count (msingleton (key (l x))) (key (l x))) 0)) (<= w1 (key (l x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) w1) 0) (> (count (msingleton (key (l x))) (key (r x))) 0)) (<= w1 (key (r x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) w1) 0) (> (count (msingleton (key (l x))) (key' (r x))) 0)) (<= w1 (key' (r x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) w1) 0) (> (count (msingleton (key (l x))) (key' x)) 0)) (<= w1 (key' x)))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) w1) 0) (> (count (msingleton (key (l x))) (key' (l x))) 0)) (<= w1 (key' (l x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) w2) 0) (> (count (msingleton (key (l x))) w1) 0)) (<= w2 w1))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) w2) 0) (> (count (msingleton (key (l x))) w2) 0)) (<= w2 w2))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) w2) 0) (> (count (msingleton (key (l x))) (key x)) 0)) (<= w2 (key x)))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) w2) 0) (> (count (msingleton (key (l x))) (key (l x))) 0)) (<= w2 (key (l x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) w2) 0) (> (count (msingleton (key (l x))) (key (r x))) 0)) (<= w2 (key (r x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) w2) 0) (> (count (msingleton (key (l x))) (key' (r x))) 0)) (<= w2 (key' (r x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) w2) 0) (> (count (msingleton (key (l x))) (key' x)) 0)) (<= w2 (key' x)))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) w2) 0) (> (count (msingleton (key (l x))) (key' (l x))) 0)) (<= w2 (key' (l x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key x)) 0) (> (count (msingleton (key (l x))) w1) 0)) (<= (key x) w1))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key x)) 0) (> (count (msingleton (key (l x))) w2) 0)) (<= (key x) w2))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key x)) 0) (> (count (msingleton (key (l x))) (key x)) 0)) (<= (key x) (key x)))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key x)) 0) (> (count (msingleton (key (l x))) (key (l x))) 0)) (<= (key x) (key (l x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key x)) 0) (> (count (msingleton (key (l x))) (key (r x))) 0)) (<= (key x) (key (r x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key x)) 0) (> (count (msingleton (key (l x))) (key' (r x))) 0)) (<= (key x) (key' (r x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key x)) 0) (> (count (msingleton (key (l x))) (key' x)) 0)) (<= (key x) (key' x)))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key x)) 0) (> (count (msingleton (key (l x))) (key' (l x))) 0)) (<= (key x) (key' (l x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key (l x))) 0) (> (count (msingleton (key (l x))) w1) 0)) (<= (key (l x)) w1))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key (l x))) 0) (> (count (msingleton (key (l x))) w2) 0)) (<= (key (l x)) w2))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key (l x))) 0) (> (count (msingleton (key (l x))) (key x)) 0)) (<= (key (l x)) (key x)))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key (l x))) 0) (> (count (msingleton (key (l x))) (key (l x))) 0)) (<= (key (l x)) (key (l x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key (l x))) 0) (> (count (msingleton (key (l x))) (key (r x))) 0)) (<= (key (l x)) (key (r x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key (l x))) 0) (> (count (msingleton (key (l x))) (key' (r x))) 0)) (<= (key (l x)) (key' (r x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key (l x))) 0) (> (count (msingleton (key (l x))) (key' x)) 0)) (<= (key (l x)) (key' x)))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key (l x))) 0) (> (count (msingleton (key (l x))) (key' (l x))) 0)) (<= (key (l x)) (key' (l x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key (r x))) 0) (> (count (msingleton (key (l x))) w1) 0)) (<= (key (r x)) w1))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key (r x))) 0) (> (count (msingleton (key (l x))) w2) 0)) (<= (key (r x)) w2))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key (r x))) 0) (> (count (msingleton (key (l x))) (key x)) 0)) (<= (key (r x)) (key x)))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key (r x))) 0) (> (count (msingleton (key (l x))) (key (l x))) 0)) (<= (key (r x)) (key (l x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key (r x))) 0) (> (count (msingleton (key (l x))) (key (r x))) 0)) (<= (key (r x)) (key (r x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key (r x))) 0) (> (count (msingleton (key (l x))) (key' (r x))) 0)) (<= (key (r x)) (key' (r x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key (r x))) 0) (> (count (msingleton (key (l x))) (key' x)) 0)) (<= (key (r x)) (key' x)))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key (r x))) 0) (> (count (msingleton (key (l x))) (key' (l x))) 0)) (<= (key (r x)) (key' (l x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' (r x))) 0) (> (count (msingleton (key (l x))) w1) 0)) (<= (key' (r x)) w1))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' (r x))) 0) (> (count (msingleton (key (l x))) w2) 0)) (<= (key' (r x)) w2))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' (r x))) 0) (> (count (msingleton (key (l x))) (key x)) 0)) (<= (key' (r x)) (key x)))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' (r x))) 0) (> (count (msingleton (key (l x))) (key (l x))) 0)) (<= (key' (r x)) (key (l x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' (r x))) 0) (> (count (msingleton (key (l x))) (key (r x))) 0)) (<= (key' (r x)) (key (r x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' (r x))) 0) (> (count (msingleton (key (l x))) (key' (r x))) 0)) (<= (key' (r x)) (key' (r x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' (r x))) 0) (> (count (msingleton (key (l x))) (key' x)) 0)) (<= (key' (r x)) (key' x)))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' (r x))) 0) (> (count (msingleton (key (l x))) (key' (l x))) 0)) (<= (key' (r x)) (key' (l x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' x)) 0) (> (count (msingleton (key (l x))) w1) 0)) (<= (key' x) w1))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' x)) 0) (> (count (msingleton (key (l x))) w2) 0)) (<= (key' x) w2))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' x)) 0) (> (count (msingleton (key (l x))) (key x)) 0)) (<= (key' x) (key x)))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' x)) 0) (> (count (msingleton (key (l x))) (key (l x))) 0)) (<= (key' x) (key (l x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' x)) 0) (> (count (msingleton (key (l x))) (key (r x))) 0)) (<= (key' x) (key (r x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' x)) 0) (> (count (msingleton (key (l x))) (key' (r x))) 0)) (<= (key' x) (key' (r x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' x)) 0) (> (count (msingleton (key (l x))) (key' x)) 0)) (<= (key' x) (key' x)))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' x)) 0) (> (count (msingleton (key (l x))) (key' (l x))) 0)) (<= (key' x) (key' (l x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' (l x))) 0) (> (count (msingleton (key (l x))) w1) 0)) (<= (key' (l x)) w1))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' (l x))) 0) (> (count (msingleton (key (l x))) w2) 0)) (<= (key' (l x)) w2))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' (l x))) 0) (> (count (msingleton (key (l x))) (key x)) 0)) (<= (key' (l x)) (key x)))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' (l x))) 0) (> (count (msingleton (key (l x))) (key (l x))) 0)) (<= (key' (l x)) (key (l x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' (l x))) 0) (> (count (msingleton (key (l x))) (key (r x))) 0)) (<= (key' (l x)) (key (r x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' (l x))) 0) (> (count (msingleton (key (l x))) (key' (r x))) 0)) (<= (key' (l x)) (key' (r x))))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' (l x))) 0) (> (count (msingleton (key (l x))) (key' x)) 0)) (<= (key' (l x)) (key' x)))))
(assert (=> (mleq (keys (r (l x))) (msingleton (key (l x)))) (=> (and (> (count (keys (r (l x))) (key' (l x))) 0) (> (count (msingleton (key (l x))) (key' (l x))) 0)) (<= (key' (l x)) (key' (l x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) w1) 0) (> (count (msingleton (key (r x))) w1) 0)) (<= w1 w1))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) w1) 0) (> (count (msingleton (key (r x))) w2) 0)) (<= w1 w2))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) w1) 0) (> (count (msingleton (key (r x))) (key x)) 0)) (<= w1 (key x)))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) w1) 0) (> (count (msingleton (key (r x))) (key (l x))) 0)) (<= w1 (key (l x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) w1) 0) (> (count (msingleton (key (r x))) (key (r x))) 0)) (<= w1 (key (r x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) w1) 0) (> (count (msingleton (key (r x))) (key' (r x))) 0)) (<= w1 (key' (r x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) w1) 0) (> (count (msingleton (key (r x))) (key' x)) 0)) (<= w1 (key' x)))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) w1) 0) (> (count (msingleton (key (r x))) (key' (l x))) 0)) (<= w1 (key' (l x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) w2) 0) (> (count (msingleton (key (r x))) w1) 0)) (<= w2 w1))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) w2) 0) (> (count (msingleton (key (r x))) w2) 0)) (<= w2 w2))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) w2) 0) (> (count (msingleton (key (r x))) (key x)) 0)) (<= w2 (key x)))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) w2) 0) (> (count (msingleton (key (r x))) (key (l x))) 0)) (<= w2 (key (l x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) w2) 0) (> (count (msingleton (key (r x))) (key (r x))) 0)) (<= w2 (key (r x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) w2) 0) (> (count (msingleton (key (r x))) (key' (r x))) 0)) (<= w2 (key' (r x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) w2) 0) (> (count (msingleton (key (r x))) (key' x)) 0)) (<= w2 (key' x)))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) w2) 0) (> (count (msingleton (key (r x))) (key' (l x))) 0)) (<= w2 (key' (l x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key x)) 0) (> (count (msingleton (key (r x))) w1) 0)) (<= (key x) w1))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key x)) 0) (> (count (msingleton (key (r x))) w2) 0)) (<= (key x) w2))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key x)) 0) (> (count (msingleton (key (r x))) (key x)) 0)) (<= (key x) (key x)))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key x)) 0) (> (count (msingleton (key (r x))) (key (l x))) 0)) (<= (key x) (key (l x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key x)) 0) (> (count (msingleton (key (r x))) (key (r x))) 0)) (<= (key x) (key (r x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key x)) 0) (> (count (msingleton (key (r x))) (key' (r x))) 0)) (<= (key x) (key' (r x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key x)) 0) (> (count (msingleton (key (r x))) (key' x)) 0)) (<= (key x) (key' x)))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key x)) 0) (> (count (msingleton (key (r x))) (key' (l x))) 0)) (<= (key x) (key' (l x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key (l x))) 0) (> (count (msingleton (key (r x))) w1) 0)) (<= (key (l x)) w1))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key (l x))) 0) (> (count (msingleton (key (r x))) w2) 0)) (<= (key (l x)) w2))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key (l x))) 0) (> (count (msingleton (key (r x))) (key x)) 0)) (<= (key (l x)) (key x)))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key (l x))) 0) (> (count (msingleton (key (r x))) (key (l x))) 0)) (<= (key (l x)) (key (l x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key (l x))) 0) (> (count (msingleton (key (r x))) (key (r x))) 0)) (<= (key (l x)) (key (r x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key (l x))) 0) (> (count (msingleton (key (r x))) (key' (r x))) 0)) (<= (key (l x)) (key' (r x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key (l x))) 0) (> (count (msingleton (key (r x))) (key' x)) 0)) (<= (key (l x)) (key' x)))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key (l x))) 0) (> (count (msingleton (key (r x))) (key' (l x))) 0)) (<= (key (l x)) (key' (l x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key (r x))) 0) (> (count (msingleton (key (r x))) w1) 0)) (<= (key (r x)) w1))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key (r x))) 0) (> (count (msingleton (key (r x))) w2) 0)) (<= (key (r x)) w2))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key (r x))) 0) (> (count (msingleton (key (r x))) (key x)) 0)) (<= (key (r x)) (key x)))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key (r x))) 0) (> (count (msingleton (key (r x))) (key (l x))) 0)) (<= (key (r x)) (key (l x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key (r x))) 0) (> (count (msingleton (key (r x))) (key (r x))) 0)) (<= (key (r x)) (key (r x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key (r x))) 0) (> (count (msingleton (key (r x))) (key' (r x))) 0)) (<= (key (r x)) (key' (r x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key (r x))) 0) (> (count (msingleton (key (r x))) (key' x)) 0)) (<= (key (r x)) (key' x)))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key (r x))) 0) (> (count (msingleton (key (r x))) (key' (l x))) 0)) (<= (key (r x)) (key' (l x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' (r x))) 0) (> (count (msingleton (key (r x))) w1) 0)) (<= (key' (r x)) w1))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' (r x))) 0) (> (count (msingleton (key (r x))) w2) 0)) (<= (key' (r x)) w2))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' (r x))) 0) (> (count (msingleton (key (r x))) (key x)) 0)) (<= (key' (r x)) (key x)))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' (r x))) 0) (> (count (msingleton (key (r x))) (key (l x))) 0)) (<= (key' (r x)) (key (l x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' (r x))) 0) (> (count (msingleton (key (r x))) (key (r x))) 0)) (<= (key' (r x)) (key (r x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' (r x))) 0) (> (count (msingleton (key (r x))) (key' (r x))) 0)) (<= (key' (r x)) (key' (r x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' (r x))) 0) (> (count (msingleton (key (r x))) (key' x)) 0)) (<= (key' (r x)) (key' x)))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' (r x))) 0) (> (count (msingleton (key (r x))) (key' (l x))) 0)) (<= (key' (r x)) (key' (l x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' x)) 0) (> (count (msingleton (key (r x))) w1) 0)) (<= (key' x) w1))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' x)) 0) (> (count (msingleton (key (r x))) w2) 0)) (<= (key' x) w2))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' x)) 0) (> (count (msingleton (key (r x))) (key x)) 0)) (<= (key' x) (key x)))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' x)) 0) (> (count (msingleton (key (r x))) (key (l x))) 0)) (<= (key' x) (key (l x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' x)) 0) (> (count (msingleton (key (r x))) (key (r x))) 0)) (<= (key' x) (key (r x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' x)) 0) (> (count (msingleton (key (r x))) (key' (r x))) 0)) (<= (key' x) (key' (r x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' x)) 0) (> (count (msingleton (key (r x))) (key' x)) 0)) (<= (key' x) (key' x)))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' x)) 0) (> (count (msingleton (key (r x))) (key' (l x))) 0)) (<= (key' x) (key' (l x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' (l x))) 0) (> (count (msingleton (key (r x))) w1) 0)) (<= (key' (l x)) w1))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' (l x))) 0) (> (count (msingleton (key (r x))) w2) 0)) (<= (key' (l x)) w2))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' (l x))) 0) (> (count (msingleton (key (r x))) (key x)) 0)) (<= (key' (l x)) (key x)))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' (l x))) 0) (> (count (msingleton (key (r x))) (key (l x))) 0)) (<= (key' (l x)) (key (l x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' (l x))) 0) (> (count (msingleton (key (r x))) (key (r x))) 0)) (<= (key' (l x)) (key (r x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' (l x))) 0) (> (count (msingleton (key (r x))) (key' (r x))) 0)) (<= (key' (l x)) (key' (r x))))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' (l x))) 0) (> (count (msingleton (key (r x))) (key' x)) 0)) (<= (key' (l x)) (key' x)))))
(assert (=> (mleq (keys (r (r x))) (msingleton (key (r x)))) (=> (and (> (count (keys (r (r x))) (key' (l x))) 0) (> (count (msingleton (key (r x))) (key' (l x))) 0)) (<= (key' (l x)) (key' (l x))))))

(assert (= (count emptymset w1 ) 0))
(assert (= (count emptymset w2 ) 0))
(assert (= (count emptymset (key x) ) 0))
(assert (= (count emptymset (key (l x)) ) 0))
(assert (= (count emptymset (key (r x)) ) 0))
(assert (= (count emptymset (key' (r x)) ) 0))
(assert (= (count emptymset (key' x) ) 0))
(assert (= (count emptymset (key' (l x)) ) 0))


(define (unroll-heap (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
    ) 
    (and
      (not (= arg0 nil))
      (= (l arg0) nil)
      (= (r arg0) nil)
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (= (r arg0) nil)
      (not (= arg0 (l arg0)))
      (heap (l arg0))
      (mleq (keys (l arg0)) (msingleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (r arg0) nil))
      (= (l arg0) nil)
      (not (= arg0 (r arg0)))
      (heap (r arg0))
      (mleq (keys (r arg0)) (msingleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (not (= (r arg0) nil))
      (not (= arg0 (l arg0)))
      (not (= arg0 (r arg0)))
      (not (= (l arg0) (r arg0)))
      (heap (l arg0))
      (heap (r arg0))
      (mleq (keys (l arg0)) (msingleton (key arg0)))
      (mleq (keys (r arg0)) (msingleton (key arg0)))
    )
))

(define (unroll-heap1 (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
    ) 
    (and
      (not (= arg0 nil))
      (= (l arg0) nil)
      (= (r arg0) nil)
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (= (r arg0) nil)
      (not (= arg0 (l arg0)))
      (heap1 (l arg0))
      (mleq (keys1 (l arg0)) (msingleton (key' arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (r arg0) nil))
      (= (l arg0) nil)
      (not (= arg0 (r arg0)))
      (heap1 (r arg0))
      (mleq (keys1 (r arg0)) (msingleton (key' arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (not (= (r arg0) nil))
      (not (= arg0 (l arg0)))
      (not (= arg0 (r arg0)))
      (not (= (l arg0) (r arg0)))
      (heap1 (l arg0))
      (heap1 (r arg0))
      (mleq (keys1 (l arg0)) (msingleton (key' arg0)))
      (mleq (keys1 (r arg0)) (msingleton (key' arg0)))
    )
))

(define (unroll-heap' (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
    ) 
    (and
      (not (= arg0 nil))
      (= (l' arg0) nil)
      (= (r' arg0) nil)
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (= (r' arg0) nil)
      (not (= arg0 (l' arg0)))
      (heap' (l' arg0))
      (mleq (keys' (l' arg0)) (msingleton (key' arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (r' arg0) nil))
      (= (l' arg0) nil)
      (not (= arg0 (r' arg0)))
      (heap' (r' arg0))
      (mleq (keys' (r' arg0)) (msingleton (key' arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (not (= (r' arg0) nil))
      (not (= arg0 (l' arg0)))
      (not (= arg0 (r' arg0)))
      (not (= (l' arg0) (r' arg0)))
      (heap' (l' arg0))
      (heap' (r' arg0))
      (mleq (keys' (l' arg0)) (msingleton (key' arg0)))
      (mleq (keys' (r' arg0)) (msingleton (key' arg0)))
    )
))

(define (unroll-negheap' (arg0 Loc))
  (not (or
    (and 
      (= arg0 nil)
    ) 
    (and
      (not (= arg0 nil))
      (= (l' arg0) nil)
      (= (r' arg0) nil)
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (= (r' arg0) nil)
      (not (= arg0 (l' arg0)))
      (heap' (l' arg0))
      (or 
         (mleq (keys' (l' arg0)) (msingleton (key' arg0)))
         (not (< w1 w2))
         (= (count (msingleton (key' arg0)) w1) 0)
         (= (count (keys' (l' arg0)) w2) 0)
      )
    )
    (and
      (not (= arg0 nil))
      (not (= (r' arg0) nil))
      (= (l' arg0) nil)
      (not (= arg0 (r' arg0)))
      (heap' (r' arg0))
      (or 
         (mleq (keys' (r' arg0)) (msingleton (key' arg0)))
         (not (< w1 w2))
         (= (count (msingleton (key' arg0)) w1) 0)
         (= (count (keys' (r' arg0)) w2) 0)
      )
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (not (= (r' arg0) nil))
      (not (= arg0 (l' arg0)))
      (not (= arg0 (r' arg0)))
      (not (= (l' arg0) (r' arg0)))
      (heap' (l' arg0))
      (heap' (r' arg0))
      (or 
         (mleq (keys' (l' arg0)) (msingleton (key' arg0)))
         (not (< w1 w2))
         (= (count (msingleton (key' arg0)) w1) 0)
         (= (count (keys' (l' arg0)) w2) 0)
      )
      (or 
         (mleq (keys' (r' arg0)) (msingleton (key' arg0)))
         (not (< w1 w2))
         (= (count (msingleton (key' arg0)) w1) 0)
         (= (count (keys' (r' arg0)) w2) 0)
      )
    )
)))


(define (unroll-keys (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (meq (keys arg0) emptymset)
    )
    (and
      (not (= arg0 nil))
      (= (l arg0) nil)
      (= (r arg0) nil)
      (meq (keys arg0) (msingleton (key arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (= (r arg0) nil)
      (not (= arg0 (l arg0)))
      (meq (keys arg0) (munion (keys (l arg0)) (msingleton (key arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r arg0) nil))
      (= (l arg0) nil)
      (not (= arg0 (r arg0)))
      (meq (keys arg0) (munion (keys (r arg0)) (msingleton (key arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (not (= (r arg0) nil))
      (not (= arg0 (l arg0)))
      (not (= arg0 (r arg0)))
      (not (= (l arg0) (r arg0)))
      (meq (keys arg0) (munion (munion (keys (l arg0)) (keys (r arg0))) (msingleton (key arg0))))
    )
))

(define (unroll-keys1 (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (meq (keys1 arg0) emptymset)
    )
    (and
      (not (= arg0 nil))
      (= (l arg0) nil)
      (= (r arg0) nil)
      (meq (keys1 arg0) (msingleton (key' arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (= (r arg0) nil)
      (not (= arg0 (l arg0)))
      (meq (keys1 arg0) (munion (keys1 (l arg0)) (msingleton (key' arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r arg0) nil))
      (= (l arg0) nil)
      (not (= arg0 (r arg0)))
      (meq (keys1 arg0) (munion (keys1 (r arg0)) (msingleton (key' arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l arg0) nil))
      (not (= (r arg0) nil))
      (not (= arg0 (l arg0)))
      (not (= arg0 (r arg0)))
      (not (= (l arg0) (r arg0)))
      (meq (keys1 arg0) (munion (munion (keys1 (l arg0)) (keys1 (r arg0))) (msingleton (key' arg0))))
    )
))

(define (unroll-keys' (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (meq (keys' arg0) emptymset)
    )
    (and
      (not (= arg0 nil))
      (= (l' arg0) nil)
      (= (r' arg0) nil)
      (meq (keys' arg0) (msingleton (key' arg0)))
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (= (r' arg0) nil)
      (not (= arg0 (l' arg0)))
      (meq (keys' arg0) (munion (keys' (l' arg0)) (msingleton (key' arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (r' arg0) nil))
      (= (l' arg0) nil)
      (not (= arg0 (r' arg0)))
      (meq (keys' arg0) (munion (keys' (r' arg0)) (msingleton (key' arg0))))
    )
    (and
      (not (= arg0 nil))
      (not (= (l' arg0) nil))
      (not (= (r' arg0) nil))
      (not (= arg0 (l' arg0)))
      (not (= arg0 (r' arg0)))
      (not (= (l' arg0) (r' arg0)))
      (meq (keys' arg0) (munion (munion (keys' (l' arg0)) (keys' (r' arg0))) (msingleton (key' arg0))))
    )
))


(define (precondition (arg0 Loc))
  (and
     (not (= arg0 nil))
     (heap (l arg0))
     (heap (r arg0))
  )     
)

(define (precondition1 (arg0 Loc))
  (and
     (not (= arg0 nil))
     (heap1 (l arg0))
     (heap1 (r arg0))
  )     
)

(define (postcondition (arg0 Loc) (arg1 Loc))
  (and 
    (heap' (arg1))
    (meq (keys arg0) (keys' arg1))
  )
)

(define (negpostcondition (arg0 Loc) (arg1 Loc))
  (or
    (not (heap' (arg1)))
    (and 
       (not (meq (keys arg0) (keys' arg1)))
       (not (= (count (keys arg0) w1) (count (keys' arg1) w1)))
    )
  )
)

(define (postcondition1 (arg0 Loc) (arg1 Loc))
  (and 
    (heap' (arg1))
    (meq (keys1 arg0) (keys' arg1))
  )
)

(assert (iff cond1
  (and
     (= (r x) nil)
     (not (= (l x) nil))
     (> (key (l x)) (key x))
  )
))

(assert (iff cond2
  (and
     (= (l x) nil)
     (not (= (r x) nil))
     (> (key (r x)) (key x))
  )
))


(assert (iff cond3
  (and
     (not (= (l x) nil))
     (not (= (r x) nil))
     (> (key (l x)) (key x))
     (>= (key (l x)) (key (r x)))
  )
))

(assert (iff cond4
  (and
     (not (= (l x) nil))
     (not (= (r x) nil))
     (> (key (r x)) (key x))
     (> (key (r x)) (key (l x)))
  )
))



; Path2,4

(declare-fun p24vc1 () Bool)
(assert (iff p24vc1
  (=> 
     (and
       (precondition x)
       (unroll-keys x)
       (=> (heap x) (unroll-heap x))
       (unroll-keys (l x))
       (=> (heap (l x)) (unroll-heap (l x)))
       (unroll-keys (r x))
       (=> (heap (r x)) (unroll-heap (r x)))
       (or 
         (and (not cond1) (not cond2) (not cond3) cond4)
         (and (not cond1) cond2)
       )
       (= (key x) (key' (r x)))
       (= (key' x) (key (r x)))
       (= (key (l x)) (key' (l x)))
       (iff (heap (l (l x))) (heap1 (l (l x))))
       (meq (keys (l (l x))) (keys1 (l (l x))))
       (iff (heap (r (l x))) (heap1 (r (l x))))
       (meq (keys (r (l x))) (keys1 (r (l x))))
       (iff (heap (l (r x))) (heap1 (l (r x))))
       (meq (keys (l (r x))) (keys1 (l (r x))))
       (iff (heap (r (r x))) (heap1 (r (r x))))
       (meq (keys (r (r x))) (keys1 (r (r x))))
     )
     (precondition1 (r x))
  )
))



(assert (not p24vc1))
(check-sat)
(model)